
	;; =========================================================================================
	;; MANAGER DE ACTORES 
	;; =========================================================================================

	;; CODIGO ========================================================

	;; Metodos principales:

	;; * initActors			-> Inicializa el buffer de actors de un mismo tipo
	;; * addActor 			-> Anyade un nuevo actor 
	;; * processActorMng		-> Procesa todos los actores de un mismo tipo

	;; ----------------------------------------------------------------

	;; Inicializa el buffer de actors de un mismo tipo

	;; Entrada:
	;; 	IX = puntero a lista de actors
	;;  	E = tamanyo de la lista
	;;  	B = numero de actors maximo
	;; 	HL = datos fijos

initActors
	ld	d,0
	ld	(ix + actorMng_nActors),d
	ld	(ix + actorMng_size),e
	inc	ix
	inc	ix
initActors_loop
	ld	(ix + actor_state_off),d

	push	de
	push	hl

	ld	d,ixh
	ld	e,ixl

;	repeat	spr_frames_off
	repeat	spr_draw_mode_off
	inc	de
	rend

	ldi				;; +3 (.b) = draw mode
	ldi				;; +4 (.w) = frames
	ldi
	ldi				;; +6 (.w) = animaciones
	ldi

	repeat	spr_width_off - spr_anims_off - 2
	inc	de
	rend

	ldi				;; +8 (.b) = ancho	(0 = 16, #10 = 20, ...)
	ldi				;; +9 (.b) = alto en pixeles
	ldi				;; +10 (.b) = ancho en tiles
	ldi				;; +11 (.b) = pivotX
	ldi				;; +12 (.b) = pivotY

	push	hl
	ld	hl,actor_collisionbb_xr_off - spr_pivot_y_off - 1
	add	hl,de
	ex	hl,de
	pop	hl

	ldi				;; +32 (.b) = actor_collisionbb_xr_off
	ldi				;; +33 (.b) = actor_collisionbb_yr_off
	ldi				;; +34 (.b) = actor_collisionbb_w_off
	ldi				;; +35 (.b) = actor_collisionbb_h_off

	pop	hl
	pop	de
	add	ix,de
	djnz	initActors_loop

	ret

	;; Anyade un nuevo actor 

	;; Entrada:
	;; 	IX = puntero a lista de actors (por su inicio)

	;; Salida:
	;;	IX = puntero a una ubicacio libre para el actor

addActor
	inc	(ix + actorMng_nActors)

	;; Devuelve el puntero a una ubicacion libre para insertar un actor (igual que addActor pero si incrementar el contador)

getFreeActor
	ld	bc,actorMng_offset
	add	ix,bc
	ld	c,(ix + actorMng_size - actorMng_offset)
	xor	a
getFreeActor_loop

	repeat	4

	cp	(ix + actor_state_off)
	ret	z
	add	ix,bc

	rend

	jr	getFreeActor_loop

	;; Procesa todos los actores de un mismo tipo

	;; Entrada:
	;; 	IX = puntero a lista de actors
	;;	HL = puntero a la rutina process del actor

processActorMng
	ld	a,(ix)
	or	a
	ret	z

	ld	(processActorMng_jp + 1),hl
	ld	(nActorCounter),a
	ld	(currentActorList_start + 1),ix
	ld	bc,actorMng_offset
	add	ix,bc
	ld	c,(ix + actorMng_size - actorMng_offset)
	ld	(actor_process_nextActor + 1),bc
	xor	a
	jr	processActor_start

	;; elimina el actor

actor_process_back_remove_actor			;; si el actor debe eliminarse vuelve aqui desde la rutina process
	ld	(ix + actor_state_off),ACTOR_STATE_UNUSED
currentActorList_start
	ld	hl,0
	dec	(hl)
actor_process_back
	ld	hl,nActorCounter
	dec	(hl)
	ret	z

actor_process_nextActor				;; si el actor no debe eliminarse vuelve aqui desde la rutina process
	ld	bc,0
	xor	a
actor_process_nextActor_q
	add	ix,bc

processActor_start
	cp	(ix + actor_state_off)
processActorMng_jp
	jp	nz,0				;;actor_process_nextActor
	jr	actor_process_nextActor_q

	;; DATOS =========================================================

nActorCounter
	db	0
