
	;; CONSTANTES DE ACTORS ------------------------------------------------

					;; Offsets a la estructura de datos de un actor

actor_state_off				EQU	spr_extends_off			;; +19	.b
actor_gravity_state_off			EQU	actor_state_off + 1		;; +20	.b
actor_flags_off				EQU	actor_gravity_state_off + 1	;; +21	.b
actor_x_world_off			EQU	actor_flags_off + 1		;; +22	.w	; sin coma fija
actor_y_world_off			EQU	actor_x_world_off + 2		;; +24	.w	; entero
actor_y_world_h_off			EQU	actor_y_world_off + 1		;; +25		; entero
actor_vertical_impulse_off		EQU	actor_y_world_h_off + 1		;; +26	.w	; 8 bits de coma fija
actor_speed_off				EQU	actor_vertical_impulse_off + 2	;; +28	.w
actor_route_x_off			EQU	actor_speed_off + 2		;; +30	.w
actor_route_y_off			EQU	actor_route_x_off + 2		;; +32	.w
actor_collisionbb_xr_off		EQU	actor_route_y_off + 2		;; +34	.b
actor_collisionbb_yr_off		EQU	actor_collisionbb_xr_off + 1	;; +35	.b
actor_collisionbb_w_off			EQU	actor_collisionbb_yr_off + 1	;; +36	.b
actor_collisionbb_h_off			EQU	actor_collisionbb_w_off + 1	;; +37	.b
actor_collisionbb_x1_off		EQU	actor_collisionbb_h_off + 1	;; +38	.b	* cache
actor_collisionbb_y1_off		EQU	actor_collisionbb_x1_off + 1	;; +39	.b	* cache
actor_collisionbb_x2_off		EQU	actor_collisionbb_y1_off + 1	;; +40	.b	* cache
actor_collisionbb_y2_off		EQU	actor_collisionbb_x2_off + 1	;; +41	.b	* cache
actor_collisionbb_xt1_off		EQU	actor_collisionbb_y2_off + 1	;; +42	.b	* cache
actor_collisionbb_yt1_off		EQU	actor_collisionbb_xt1_off + 1	;; +43	.b	* cache
actor_collisionbb_xt2_off		EQU	actor_collisionbb_yt1_off + 1	;; +44	.b	* cache
actor_collisionbb_yt2_off		EQU	actor_collisionbb_xt2_off + 1	;; +45	.b	* cache
actor_collisionbb_wt_off		EQU	actor_collisionbb_yt2_off + 1	;; +46	.b	* cache
actor_collisionbb_ht_off		EQU	actor_collisionbb_wt_off + 1	;; +47	.b	* cache
actor_extends_off			EQU	actor_collisionbb_ht_off + 1	;; +48

					;; estados del actor
ACTOR_STATE_UNUSED			EQU	0
ACTOR_STATE_STOPPED			EQU	1
ACTOR_STATE_WALKING			EQU	2
ACTOR_STATE_JUMPING			EQU	3
ACTOR_STATE_FLYING			EQU	4
ACTOR_STATE_ROTATING			EQU	5
					; ...

					;; estado de movimiento vertical (gravidez)
ACTOR_GRAVITY_STATE_WEIGHTLESSNESS	EQU	0			;; ingravidez
ACTOR_GRAVITY_STATE_GOING_UP		EQU	1*2			;; subiendo
ACTOR_GRAVITY_STATE_GOING_DOWN		EQU	2*2			;; bajando

					;; constantes de gravidez
GRAVITY_SPEED				EQU	#60
VERTICAL_IMPULSE_MAX			EQU	8*#100
VERTICAL_IMPULSE_MIN			EQU	-8*#100

					;; Ids de tipos de colision segun su direccion
TOP_COLLISION				EQU	0
BOTTOM_COLLISION			EQU	1
LEFT_COLLISION				EQU	2
RIGHT_COLLISION				EQU	3

					;; bits de actor_flags
X_ROUTE_ACTIVE_BIT			EQU	0			;; indica que tiene movimiento predefinido en horizontal
Y_ROUTE_ACTIVE_BIT			EQU	1			;; indica que tiene movimiento predefinido en vertical
CAMERA_TRACKING_BIT			EQU	2			;; indica que lo sigue la camara
H_HIDDEN_BIT				EQU	3			;; indiac que esta oculto (fuera de los margenes visibles en horizontal)

					;; valores correspondientos a los bits de actor_flags
X_ROUTE_ACTIVE_VALUE			EQU	1
Y_ROUTE_ACTIVE_VALUE			EQU	2
CAMERA_TRACKING_VALUE			EQU	4
H_HIDDEN_VALUE				EQU	8


ROUTE_END_CODE				EQU	#80			;; codigo que define el final de los datos en un recorrido predefinido
