
	;; =========================================================================================
	;; CLASE ABSTRACTA ENEMIGOS (metodos comunes a todos los enemigos)
	;; =========================================================================================

	; CODIGO -------------------------------------------------------

	;; Metodos principales:

	;; * enemy_initSupport		-> Inicializa el soporte para los enemigos
	;; * enemy_create		-> Creacion generica de un enemigo (inicializa solo parametros genericos de enemigos)
	;; * enemy_remove		-> Elimina un enemigo (debe llamarse desde el metodo process del enemigo)


	;; Inicializa el soporte para los enemigos

enemy_initSupport
	call	bird_initSupport
	call	turtle_initSupport
	jp	coin_initSupport

	;; Creacion generica de un enemigo

	;; Entrada:
	;;	DE = puntero a guardar en enemy_gTileMap_adr_off
	;;	BC = coordenada X relativa donde debe poner el enemigo (0 / GAMEAREA_W_PIXEL)
	;;	HL = coordenada Y absoluta (8 bit de coma fija)

	;; Modifica:
	;;	A, BC, IX

enemy_create
	push	hl

	ld	hl,(h_scroll_pos)			; 6c
	add	hl,bc

	call	addActor				; modifica A, BC, IX

	ld	(ix + enemy_gTileMap_adr_off),e
	ld	(ix + enemy_gTileMap_adr_off + 1),d

	ld	(ix + actor_x_world_off),l
	ld	(ix + actor_x_world_off + 1),h

	pop	hl

	ld	(ix + actor_y_world_off),l
	ld	(ix + actor_y_world_off + 1),h

	ld	(ix + actor_flags_off),0

	ret

	;; Elimina un enemigo (debe llamarse desde el metodo process del enemigo)

	;; Entrada:
	;;	IX = Puntero a los datos del enemigo

enemy_remove
	ld	l,(ix + enemy_gTileMap_adr_off)
	ld	h,(ix + enemy_gTileMap_adr_off + 1)
	res	0,(hl)					; le quita la marca de puesto para que pueda volverse a poner
	
	jp	actor_process_back_remove_actor



