
	;; =========================================================================
	;; SOPORTE PARA SPRITES DE 4 BYTES DE ANCHO
	;; =========================================================================

	;; Metodos:

	;; * drawSprite4B_byte_even	-> Dibuja un sprite sin mascara de 4 bytes de ancho en byte par
	;; * drawSprite4B_byte_odd	-> Dibuja un sprite sin mascara de 4 bytes de ancho en byte impar
	;; * drawMskSprite4B_byte_even	-> Dibuja un sprite con mascara de 4 bytes de ancho en byte par
	;; * drawMskSprite4B_byte_odd	-> Dibuja un sprite con mascara de 4 bytes de ancho en byte impar

	;; DIBUJADO SIN MASCARA
	;; ---------------------------------------------------------------

	;; MACROS ========================================================

	;; DIBUJA UNA LINEA DE SPRITE DE 4 BYTES EMPEZANDO EN BYTE PAR

	MACRO	DRAW_BYTE_EVEN_4B	;; 38/48c

	;; HL = GFX
	;; DE = pantalla (byte par)

	ldi			;; 5c

	ld	a,(hl)		;; 2c
	ld	(de),a		;; 2c
	inc	l		;; 1c		avanza en el gfx
	NEXT_BYTE_DE		;; 4/11/14c	avanza en pantalla (byte impar)	

	ldi			;; 5c

	ld	a,(hl)		;; 2c
	ld	(de),a		;; 2c
	inc	hl		;; 2c		avanza en el gfx

	MEND

	;; DIBUJA UNA LINEA DE SPRITE DE 4 BYTES EMPEZANDO EN BYTE IMPAR

	MACRO	DRAW_BYTE_ODD_4B	;; 42/52c

	;; HL = GFX
	;; DE = pantalla (byte impar)

	ld	a,(hl)		;; 2c
	ld	(de),a		;; 2c
	inc	l		;; 1c		avanza en el gfx
	NEXT_BYTE_DE		;; 4/11/14c	avanza en pantalla (byte impar)	

	ldi			;; 5c

	ld	a,(hl)		;; 2c
	ld	(de),a		;; 2c
	inc	l		;; 1c		avanza en el gfx
	NEXT_BYTE_DE		;; 4/11/14c	avanza en pantalla (byte impar)	

	ldi			;; 5c

	MEND

	;; CODIGO =========================================================

drawSprite4B_byte_even_loop

	NEXT_SCANLINE_DE

	;; DIBUJA UN SPRITE SIN MASCARA DE 4 BYTES DE ANCHO EN BYTE PAR

	;; HL = GFX
	;; DE = pantalla
	;; A' = pantalla (byte alto)
	;; IYH = pantalla (byte bajo)
	;; IYL = altura

drawSprite4B_byte_even

	DRAW_BYTE_EVEN_4B

	dec	iyl
	ret	z

	NEXT_SCANLINE_DE

	DRAW_BYTE_EVEN_4B

	dec	iyl
	jr	nz, drawSprite4B_byte_even_loop

	ret

	;; -------------------------------------------------------------------------

drawSprite4B_byte_odd_loop

	NEXT_SCANLINE_DE

	;; DIBUJA UN SPRITE SIN MASCARA DE 4 BYTES DE ANCHO EN BYTE IMPAR

	;; HL = GFX
	;; DE = pantalla
	;; A' = pantalla (byte alto)
	;; IYH = pantalla (byte bajo)
	;; IYL = altura

drawSprite4B_byte_odd

	DRAW_BYTE_ODD_4B

	dec	iyl
	ret	z

	NEXT_SCANLINE_DE

	DRAW_BYTE_ODD_4B

	dec	iyl
	jr	nz, drawSprite4B_byte_odd_loop

	ret


	;; DIBUJADO CON MASCARA
	;; -------------------------------------------------------------------------

	;; MACROS ========================================================

	;; DIBUJA UNA LINEA DE SPRITE CON MASCARA DE 4 BYTES EMPEZANDO EN BYTE PAR

	MACRO	DRAW_MSK_BYTE_EVEN_4B	;; 49c

	;; B = tabla de mascara (byte alto)
	;; DE = GFX
	;; HL = pantalla (byte par)

	REPEAT	4/2-1

	DRAW_MSK_BYTE		;; 10c
	inc	e		;; 1c	avanza en el gfx
	inc	l		;; 1c	avanza en pantalla (byte par)

	DRAW_MSK_BYTE		;; 10c
	inc	e		;; 1c	avanza en el gfx
	NEXT_BYTE_HL		;;	avanza en pantalla (byte impar)

	REND

	DRAW_MSK_BYTE		;; 10c
	inc	e		;; 1c	avanza en el gfx
	inc	l		;; 1c	avanza en pantalla

	DRAW_MSK_BYTE		;; 10c
	inc	de

	MEND

	;; DIBUJA UNA LINEA DE SPRITE CON MASCARA DE 4 BYTES EMPEZANDO EN BYTE IMPAR

	MACRO	DRAW_MSK_BYTE_ODD_4B	;; 54c

	;; B = tabla de mascara (byte alto)
	;; DE = GFX
	;; HL = pantalla (byte impar)

	REPEAT	4/2-1

	DRAW_MSK_BYTE		;; 10c
	inc	e		;; 1c	avanza en el gfx
	NEXT_BYTE_HL		;;	avanza en pantalla (byte impar)

	DRAW_MSK_BYTE		;; 10c
	inc	e		;; 1c	avanza en el gfx
	inc	l		;; 1c	avanza en pantalla (byte par)

	REND

	DRAW_MSK_BYTE		;; 10c
	inc	e		;; 1c	avanza en el gfx
	NEXT_BYTE_HL		;;	avanza en pantalla (byte impar)

	DRAW_MSK_BYTE		;; 10c
	inc	de		;; 2c

	MEND

	;; CODIGO =========================================================

drawMskSprite4B_byte_even_loop

	NEXT_SCANLINE_HL

	;; DIBUJA UN SPRITE CON MASCARA DE 4 BYTES DE ANCHO EN BYTE PAR

	;; B = tabla de mascara (byte alto)
	;; DE = GFX
	;; HL = pantalla
	;; A' = pantalla (byte alto)
	;; IYH = pantalla (byte bajo)
	;; IYL = altura

drawMskSprite4B_byte_even

	DRAW_MSK_BYTE_EVEN_4B

	dec	iyl
	ret	z

	NEXT_SCANLINE_HL

	DRAW_MSK_BYTE_EVEN_4B

	dec	iyl
	jp	nz, drawMskSprite4B_byte_even_loop

	ret

	;; -------------------------------------------------------------------------

drawMskSprite4B_byte_odd_loop

	NEXT_SCANLINE_HL

	;; DIBUJA UN SPRITE SIN MASCARA DE 4 BYTES DE ANCHO EN BYTE IMPAR

	;; B = tabla de mascara (byte alto)
	;; DE = GFX
	;; HL = pantalla
	;; A' = pantalla (byte alto)
	;; IYH = pantalla (byte bajo)
	;; IYL = altura

drawMskSprite4B_byte_odd

	DRAW_MSK_BYTE_ODD_4B

	dec	iyl
	ret	z

	NEXT_SCANLINE_HL

	DRAW_MSK_BYTE_ODD_4B

	dec	iyl
	jp	nz, drawMskSprite4B_byte_odd_loop

	ret

