
	;; =========================================================================
	;; SOPORTE PARA SPRITES DE 6 BYTES DE ANCHO
	;; =========================================================================

	;; Metodos:

	;; * drawSprite6B_byte_even	-> Dibuja un sprite sin mascara de 6 bytes de ancho en byte par
	;; * drawSprite6B_byte_odd	-> Dibuja un sprite sin mascara de 6 bytes de ancho en byte impar
	;; * drawMskSprite6B_byte_even	-> Dibuja un sprite con mascara de 6 bytes de ancho en byte par
	;; * drawMskSprite6B_byte_odd	-> Dibuja un sprite con mascara de 6 bytes de ancho en byte impar

	;; DIBUJADO SIN MASCARA
	;; -------------------------------------------------------------------------

	;; MACROS ========================================================

	;; DIBUJA UNA LINEA DE SPRITE DE 6 BYTES EMPEZANDO EN BYTE PAR

	MACRO	DRAW_BYTE_EVEN_6B_1	;; 39/49c

	;; HL = GFX
	;; DE = pantalla (byte par)

	ldi			;; 5c

	ld	a,(hl)		;; 2c
	ld	(de),a		;; 2c
	inc	l		;; 1c		avanza en el gfx
	NEXT_BYTE_DE		;; 4/11/14c	avanza en pantalla (byte impar)	

	ldi			;; 5c

	ld	a,(hl)		;; 2c
	ld	(de),a		;; 2c
	inc	hl		;; 2c		avanza en el gfx
	NEXT_BYTE_DE		;; 4/11/14c	avanza en pantalla (byte impar)	

	ldi			;; 5c

	ld	a,(hl)		;; 2c
	ld	(de),a		;; 2c
	inc	l		;; 1c		avanza en el gfx

	MEND


	MACRO	DRAW_BYTE_EVEN_6B_2	;; 39/49c

	;; HL = GFX
	;; DE = pantalla (byte par)

	ldi			;; 5c

	ld	a,(hl)		;; 2c
	ld	(de),a		;; 2c
	inc	hl		;; 1c		avanza en el gfx
	NEXT_BYTE_DE		;; 4/11/14c	avanza en pantalla (byte impar)	

	ldi			;; 5c

	ld	a,(hl)		;; 2c
	ld	(de),a		;; 2c
	inc	l		;; 2c		avanza en el gfx
	NEXT_BYTE_DE		;; 4/11/14c	avanza en pantalla (byte impar)	

	ldi			;; 5c

	ld	a,(hl)		;; 2c
	ld	(de),a		;; 2c
	inc	hl		;; 1c		avanza en el gfx

	MEND


	;; DIBUJA UNA LINEA DE SPRITE DE 6 BYTES EMPEZANDO EN BYTE IMPAR

	MACRO	DRAW_BYTE_ODD_6B	;; 42/52c

	;; HL = GFX
	;; DE = pantalla (byte impar)

	ld	a,(hl)		;; 2c
	ld	(de),a		;; 2c
	inc	l		;; 1c		avanza en el gfx
	NEXT_BYTE_DE		;; 4/11/14c	avanza en pantalla (byte impar)	

	ldi			;; 5c

	ld	a,(hl)		;; 2c
	ld	(de),a		;; 2c
	inc	l		;; 1c		avanza en el gfx
	NEXT_BYTE_DE		;; 4/11/14c	avanza en pantalla (byte impar)	

	ldi			;; 5c

	ld	a,(hl)		;; 2c
	ld	(de),a		;; 2c
	inc	l		;; 1c		avanza en el gfx
	NEXT_BYTE_DE		;; 4/11/14c	avanza en pantalla (byte impar)	

	ldi			;; 5c

	MEND

	;; CODIGO =========================================================

drawSprite6B_byte_even_loop

	NEXT_SCANLINE_DE

	;; DIBUJA UN SPRITE SIN MASCARA DE 6 BYTES DE ANCHO EN BYTE PAR (1100c para 16 / 1640c para 24)

	;; HL = GFX
	;; DE = pantalla
	;; A' = pantalla (byte alto)
	;; IYH = pantalla (byte bajo)
	;; IYL = altura

drawSprite6B_byte_even

	DRAW_BYTE_EVEN_6B_1

	dec	iyl
	ret	z

	NEXT_SCANLINE_DE

	DRAW_BYTE_EVEN_6B_2

	dec	iyl
	jp	nz, drawSprite6B_byte_even_loop

	ret

	;; -------------------------------------------------------------------------

drawSprite6B_byte_odd_loop

	NEXT_SCANLINE_DE

	;; DIBUJA UN SPRITE SIN MASCARA DE 6 BYTES DE ANCHO EN BYTE IMPAR (1200c para 16 / 1770c para 24)

	;; HL = GFX
	;; DE = pantalla
	;; A' = pantalla (byte alto)
	;; IYH = pantalla (byte bajo)
	;; IYL = altura

drawSprite6B_byte_odd

	DRAW_BYTE_ODD_6B

	dec	iyl
	ret	z

	NEXT_SCANLINE_DE

	DRAW_BYTE_ODD_6B

	dec	iyl
	jp	nz, drawSprite6B_byte_odd_loop

	ret

	;; DIBUJADO CON MASCARA
	;; -------------------------------------------------------------------------

	;; MACROS ========================================================

	;; DIBUJA UNA LINEA DE SPRITE CON MASCARA DE 6 BYTES EMPEZANDO EN BYTE PAR

	MACRO	DRAW_MSK_BYTE_EVEN_6B_1	; 49c

	;; B = tabla de mascara (byte alto)
	;; DE = GFX
	;; HL = pantalla (byte par)


	DRAW_MSK_BYTE		;; 10c
	inc	e		;; 1c	avanza en el gfx
	inc	l		;; 1c	avanza en pantalla (byte par)

	DRAW_MSK_BYTE		;; 10c
	inc	e		;; 1c	avanza en el gfx
	NEXT_BYTE_HL		;;	avanza en pantalla (byte impar)


	DRAW_MSK_BYTE		;; 10c
	inc	e		;; 1c	avanza en el gfx
	inc	l		;; 1c	avanza en pantalla (byte par)

	DRAW_MSK_BYTE		;; 10c
	inc	de		;; 1c	avanza en el gfx
	NEXT_BYTE_HL		;;	avanza en pantalla (byte impar)


	DRAW_MSK_BYTE		;; 10c
	inc	e		;; 1c	avanza en el gfx
	inc	l		;; 1c	avanza en pantalla

	DRAW_MSK_BYTE		;; 10c
	inc	e

	MEND

	MACRO	DRAW_MSK_BYTE_EVEN_6B_2	;; 49c

	;; B = tabla de mascara (byte alto)
	;; DE = GFX
	;; HL = pantalla (byte par)


	DRAW_MSK_BYTE		;; 10c
	inc	e		;; 1c	avanza en el gfx
	inc	l		;; 1c	avanza en pantalla (byte par)

	DRAW_MSK_BYTE		;; 10c
	inc	de		;; 1c	avanza en el gfx
	NEXT_BYTE_HL		;;	avanza en pantalla (byte impar)


	DRAW_MSK_BYTE		;; 10c
	inc	e		;; 1c	avanza en el gfx
	inc	l		;; 1c	avanza en pantalla (byte par)

	DRAW_MSK_BYTE		;; 10c
	inc	e		;; 1c	avanza en el gfx
	NEXT_BYTE_HL		;;	avanza en pantalla (byte impar)


	DRAW_MSK_BYTE		;; 10c
	inc	e		;; 1c	avanza en el gfx
	inc	l		;; 1c	avanza en pantalla

	DRAW_MSK_BYTE		;; 10c
	inc	de

	MEND

	;; DIBUJA UNA LINEA DE SPRITE CON MASCARA DE 6 BYTES EMPEZANDO EN BYTE IMPAR

	MACRO	DRAW_MSK_BYTE_ODD_6B_1	;; 54c

	;; B = tabla de mascara (byte alto)
	;; DE = GFX
	;; HL = pantalla (byte impar)


	DRAW_MSK_BYTE		;; 10c
	inc	e		;; 1c	avanza en el gfx
	NEXT_BYTE_HL		;;	avanza en pantalla (byte impar)

	DRAW_MSK_BYTE		;; 10c
	inc	e		;; 1c	avanza en el gfx
	inc	l		;; 1c	avanza en pantalla (byte par)


	DRAW_MSK_BYTE		;; 10c
	inc	e		;; 1c	avanza en el gfx
	NEXT_BYTE_HL		;;	avanza en pantalla (byte impar)

	DRAW_MSK_BYTE		;; 10c
	inc	de		;; 1c	avanza en el gfx
	inc	l		;; 1c	avanza en pantalla (byte par)


	DRAW_MSK_BYTE		;; 10c
	inc	e		;; 1c	avanza en el gfx
	NEXT_BYTE_HL		;;	avanza en pantalla (byte impar)

	DRAW_MSK_BYTE		;; 10c
	inc	e		;; 2c

	MEND

	MACRO	DRAW_MSK_BYTE_ODD_6B_2	;; 54c

	;; B = tabla de mascara (byte alto)
	;; DE = GFX
	;; HL = pantalla (byte impar)


	DRAW_MSK_BYTE		;; 10c
	inc	e		;; 1c	avanza en el gfx
	NEXT_BYTE_HL		;;	avanza en pantalla (byte impar)

	DRAW_MSK_BYTE		;; 10c
	inc	de		;; 1c	avanza en el gfx
	inc	l		;; 1c	avanza en pantalla (byte par)


	DRAW_MSK_BYTE		;; 10c
	inc	e		;; 1c	avanza en el gfx
	NEXT_BYTE_HL		;;	avanza en pantalla (byte impar)

	DRAW_MSK_BYTE		;; 10c
	inc	e		;; 1c	avanza en el gfx
	inc	l		;; 1c	avanza en pantalla (byte par)

	DRAW_MSK_BYTE		;; 10c
	inc	e		;; 1c	avanza en el gfx
	NEXT_BYTE_HL		;;	avanza en pantalla (byte impar)

	DRAW_MSK_BYTE		;; 10c
	inc	de		;; 2c

	MEND

	;; CODIGO =========================================================

drawMskSprite6B_byte_even_loop

	NEXT_SCANLINE_HL

	;; DIBUJA UN SPRITE CON MASCARA DE 6 BYTES DE ANCHO EN BYTE PAR (1100c para 16 / 1640c para 24)

	;; B = tabla de mascara (byte alto)
	;; DE = GFX
	;; HL = pantalla
	;; A' = pantalla (byte alto)
	;; IYH = pantalla (byte bajo)
	;; IYL = altura

drawMskSprite6B_byte_even

	DRAW_MSK_BYTE_EVEN_6B_1

	dec	iyl
	ret	z

	NEXT_SCANLINE_HL

	DRAW_MSK_BYTE_EVEN_6B_2

	dec	iyl
	jp	nz, drawMskSprite6B_byte_even_loop

	ret

	;; -------------------------------------------------------------------------

drawMskSprite6B_byte_odd_loop

	NEXT_SCANLINE_HL

	;; DIBUJA UN SPRITE CON MASCARA DE 6 BYTES DE ANCHO EN BYTE IMPAR (1200c para 16 / 1770c para 24)

	;; B = tabla de mascara (byte alto)
	;; DE = GFX
	;; HL = pantalla
	;; A' = pantalla (byte alto)
	;; IYH = pantalla (byte bajo)
	;; IYL = altura

drawMskSprite6B_byte_odd

	DRAW_MSK_BYTE_ODD_6B_1

	dec	iyl
	ret	z

	NEXT_SCANLINE_HL

	DRAW_MSK_BYTE_ODD_6B_2

	dec	iyl
	jp	nz, drawMskSprite6B_byte_odd_loop

	ret
