
	;; =========================================================================================
	;; SOPORTE DE MAPA DE TILES
	;; =========================================================================================

	;; * Se usan tiles de 4x8 pixeles de mode 0 (1 caracter) y 4 colores

	;; * Ademas de usar solo 4 colores (colores del 0 a 3), los colores de los gfxs del fondo
	;;   deben distribuirse en cada linea segun el siguiente patron: 
	;;   color 0 (fondo) + color 1 (negro) + cualquier combinacion de colores 1 y 2 + color 1 + color 0

	;; * Los gfxs de tiles dibujados con estas limitaciones deben convertirse con la herramienta 
	;;   tools\tc.jar al formato que permite hacer el scroll de 1 pixel cambiando la paleta.
	;;   Escribe java -jar tc.jar para ver las instrucciones de la herramienta.

	;; * La herramienta convierte los tiles agrupados en un mismo gfx (puestos unos tiles debajo de otros)
	;;   siendo el primer tile el de arriba. Tambien hay que colocar a la izquierda de cada tile, el tile 
	;;   que siempre debera ir a su izquierda (ya que necesita saber los colores de los pixeles que tiene
	;;   a su izquierda). En tools\ estan los gfxs de los tiles usados en la demo, tiles_c.gif (tiles que
	;;   colisionan) y tiles_nc.gif (tiles que no colisionan), y en png el resultado de convertirlos con
	;;   la herramienta. La herramienta, una vez usa la info de los tiles colocados a la izquierda para
	;;   la conversion de colores, elimina los tiles de la izquierda en el gfx resultante. Asi, tiles_c.gif
	;;   y tiles_nc.gif tienen 16 pixeles de ancho (2 tiles) y tiles_c.png y tiles_nc.png tiene 8 pixeles
	;;   de ancho (1 tile). (ver gfxs\misc.gif para mas detalle sobre como estan hecho los tiles)

	;; * Una vez convertirdos los tiles con tc.jar, ya se pueden convertir a formato raw de CPC con el
	;;   siguiente orden de scanlines: 0, 4, 5, 1, 3, 7, 6, 2 (usa para esto tu herramienta habitual,
	;;   tc.jar no convierte a raw de CPC).

	;; * El mapeado se define comprimido por columnas, cada una con 1 byte para definir enenmigos + 3
	;;   subcolumnas para las distintas franjas de color (las 2 franjas de abajo se definen en la misma
	;;   subcolumna)

	;; * Si el byte que define enemigos es >= DINAMIC_PALETTE_CHANGES, se refiere a un cambio de paleta
	;;   en el mapeado para hacer que las distintas franjas no siempre sean de los mismos colores.
	;;   Si es < DINAMIC_PALETTE_CHANGES es el ID de un enemigo (el bit 0 indica si el enemigo esta ya
	;;   puesto). Si el byte es 0 no se pone nada. Para definir la posicion de salida de los enemigos
	;;   en el mismo byte, se definen IDs de enemigos diferentes dependiende de la posicion de salida.

	;; * Tiles vacios (todo color de fondo) se dibuja con una rutina especifica para mejorar rendimiento.

	;; * En DECOMP_TILE_MAP se guarda la informacion del mapeado descomprimido de la pantalla actual, ya 
	;;   que el mapa esta comprimido en submapas. Estos datos descomprimidos se usan para detectar
	;;   colisiones de tiles, borrar sprites dibujando tiles, etc... El buffer se compone de 64x32 tiles
	;;   al redondear a potencias de 2 las dimensiones (14 tiles mas que el area visible a lo ancho y 12 a
	;;   lo alto, aunque por ahora solo se utiliza el area visible). 
	;; * Tiles con ID >= 128 colisionan

	;; POSIBLES MEJORAS/CAMBIOS:

	;; * Cuando se dibuja una pantalla completa del mapeado para empezar por un lugar determinado, crear
	;;   tambien los enemigos e items que correspondan.

	;; * Los enemigos que colisionan con el mapeado necesitan el buffer DECOMP_TILE_MAP para detectar las
	;;   colisiones, por lo que solo se pueden mover mientras esten dentro del area cubierta por 
	;;   DECOMP_TILE_MAP, este area actualmente es el area visible, pero podrian ser 14 tiles mas a lo ancho 
	;;   como se explica arriba.

	;; * Soporte de tiles compilados (aplicados al menos en tiles que no colisionan)

	;; MACROS ========================================================

	;; DIBUJA UN TILE ------------------------------------------------

	MACRO 	DRAW_TILE		;; 100c

	;; HL = direccion del tile
	;; DE = direccion de pantalla

	;; line 0

	ldi			;; 5c
	ld	a,(hl)		;; 2c
	ld	(de),a		;; 2c
	inc	l		;; 1c
	set	5,d		;; 2c

	;; line 4

	ld	a,(hl)		;; 2c
	ld	(de),a		;; 2c
	inc	l		;; 1c
	dec	e		;; 1c
	ld	a,(hl)		;; 2c
	ld	(de),a		;; 2c
	inc	l		;; 1c
	set 	3,d		;; 2c

	;; line 5

	ldi
	ld	a,(hl)
	ld	(de),a
	inc	l
	res	5,d

	;; line 1

	ld	a,(hl)
	ld	(de),a
	inc	l
	dec	e
	ld	a,(hl)
	ld	(de),a
	inc	l
	set 	4,d

	;; line 3

	ldi
	ld	a,(hl)
	ld	(de),a
	inc	l
	set	5,d

	;; line 7

	ld	a,(hl)
	ld	(de),a
	inc	l
	dec	e
	ld	a,(hl)
	ld	(de),a
	inc	l
	res 	3,d

	;; line 6

	ldi
	ld	a,(hl)
	ld	(de),a
	inc	l
	res	5,d

	;; line 2

	ld	a,(hl)
	ld	(de),a
	inc	l
	dec	e
	ld	a,(hl)
	ld	(de),a
	res	4,d

	MEND

	;; DIBUJA UN TILE VACIO ------------------------------------------------

	MACRO 	DRAW_BLANK_TILE		;; 56c

	;; A = byte to write (0)
	;; DE = screen
	
	;; line 0

	ld	(de),a		;; 2c
	inc	e		;; 1c
	ld	(de),a		;; 2c
	set	5,d		;; 2c

	;; line 4

	ld	(de),a
	dec	e
	ld	(de),a
	set 	3,d

	;; line 5

	ld	(de),a
	inc	e
	ld	(de),a
	res	5,d

	;; line 1

	ld	(de),a
	dec	e
	ld	(de),a
	set 	4,d

	;; line 3

	ld	(de),a
	inc	e
	ld	(de),a
	set	5,d

	;; line 7

	ld	(de),a
	dec	e
	ld	(de),a
	res 	3,d

	;; line 6

	ld	(de),a
	inc	e
	ld	(de),a
	res	5,d

	;; line 2

	ld	(de),a
	dec	e
	ld	(de),a
	res	4,d

	MEND

	;; SALTA A LA SIGUIENTE FILA DE TILES EN PANTALLA --------------------------------------------

	MACRO	NEXT_TILE_ROW			; 6/8c

	;; B = GAMEAREA_W_BYTE
	;; DE = screen

	ld	a,b ;GAMEAREA_W_BYTE		; 1c
	add	e				; 1c
	ld	e,a				; 1c
	jr	nc, @drawTile_noacc		; 2/3c
	inc	d				; 1c
	res	3,d				; 2c
@drawTile_noacc

	MEND

	;; SALTA A LA SIGUIENTE COLUMNA DE TILES EN PANTALLA ------------------------------------------

	MACRO	NEXT_TILE_COLUMN		; 5c

	;; DE = screen

	inc	e				; 1c
	inc	de				; 2c
	res	3,d				; 2c

	MEND


	;; CODIGO =========================================================

	;; Metodos principales:

	;; * initMap 			-> Inicializa el mapeado, estableciendo tiles y el mapeado
	;; * reinitMap 			-> Reinicia el mapeado
	;; * setMapScreen 		-> Establece la pantalla completa del mapeado
	;; * drawTileMapScreen 		-> Dibuja una pantalla completa de tiles
	;; * getTileMapPos		-> Devuelve una posicion en el mapeado de tiles en funcion de un desplazamiento
	;; * updateTileMap		-> Actualiza el mapeado segun el scroll
	;; * clearDirtyTilesRect	-> Borra rectangulos de tiles sucios
	;; * addDirtyTilesRect		-> Anyade un rectangulo de tiles sucios
	;; * addDirtyTilesRect_doubleBuffer -> Anyade un rectangulo de tiles sucios en el otro buffer del double buffer
	;; * onTileMapCommand		-> Callback para gestionar comandos (enemigos) del mapeado
	;; * refreshMapColors		-> Actualiza los colores del mapeado (si hubo algun cambio)

	;; ----------------------------------------------------------------

	;; Inicializa el mapeado, estableciendo tiles y el mapeado

	;; (solo es necesario llamarlo una vez)

	;; Entrada:
	;; 	HL = puntero al primer gfx de tile
	;;	DE = tileMap
	;;	BC = tileMap_len
	;;	(h_scroll_pos) = posicion inicial en el mapeado

initMap
	push	de
	push	bc

	;; Crea la lista de punteros a tiles para optimizacion de velocidad

	ld	de,-TILE_LEN * 1
	add	hl,de
	ex	hl,de
	ld	bc,TILE_LEN
	ld	hl,tilesAdr_l

create_tileAdr_loop
	ex	hl,de
	add	hl,bc
	ex	hl,de

	ld	(hl),e
	inc	h
	ld	(hl),d
	dec	h
	inc	l

	jr	nz, create_tileAdr_loop

	;; pokea los valores del mapeado en el codigo

	pop	bc
	pop	de

	LD______HL_BC
	srl	h
	rr	l
	srl	h
	rr	l				;; HL = BC / 4

	ld	(_myTileMap1 + 1),de
	ld	(_myTileMap2 + 1),de

	ld	(_myTileMapColumnLen1 + 1),hl
	ld	(_myTileMapColumnLen2 + 1),hl

	IF	LOOP_TILEMAP

	ld	(_myTileMapLen1 + 1),bc

	xor	a
	ld	h,a
	ld	l,a
	sbc	hl,bc
	ld	(_myTileMapLen2i + 1),hl

	ex	hl,de
	add	hl,bc
	ex	hl,de

	xor	a
	ld	h,a
	ld	l,a
	sbc	hl,de
	ld	(_myTileMapEnd1i + 1),hl

	add	hl,bc
	ld	(_myTileMapEnd2i + 1),hl

	ENDIF

	;; Reinicia el mapeado en (h_scroll_pos)

reinitMap

	;; reinicia la info de los enemigos (para que si tenia alguna activo, lo desactive para que vuelva a salir)

_myTileMap1
	ld	hl,tileMap		;; posicion en tileMap
_myTileMapColumnLen1
	ld	bc,n_tileMap_columns

	ld	de,TILEMAP_COLUMN_LEN
reinitMap_resetEnemInfo_loop

	IF	DINAMIC_PALETTE_CHANGES

	ld	a,(hl)
	cp	DINAMIC_PALETTE_CHANGES
	jr	nc, $+4

	ENDIF

	res	0,(hl)			;; si tenia algun enemigo activo, lo desactiva para que vuelva a salir
	add	hl,de
	dec	bc
	ld	a,b
	or	c
	jr	nz, reinitMap_resetEnemInfo_loop

	;; inicializa soporte de rectangulo de tiles sucios para borrado de sprites chicos y animacion de tiles sueltos

	xor	a
	ld	(nDirtyTilesRect0),a
	ld	(nDirtyTilesRect1),a

	ld	hl,dirty_tiles_rect0
	ld	(dirtyTilesRect0_adr),hl

	ld	hl,dirty_tiles_rect1
	ld	(dirtyTilesRect1_adr),hl

	IF	DINAMIC_PALETTE_CHANGES

	ld	(_nextMapColors + 1),a

	ENDIF

	;; inicializa soporte de tiles sueltos sucios para borrado de sprites chicos y animacion de tiles sueltos	

;	ld	(nDirtyTiles0),a
;	ld	(nDirtyTiles1),a

;	ld	hl,
;	ld	(dirtyTiles0_adr),hl

;	ld	hl,
;	ld	(dirtyTiles1_adr),hl

	ld	bc,(h_scroll_pos)

	;; Establece la pantalla completa del mapeado ---------------------------

	;; BC = desplazamiento de pantalla

setMapScreen
	call	getTileMapPos
	ld	(tileMap_adr),hl
	push	bc			;; guarda el desplazamiento de pantalla

	;; borra la pantalla (buffer 1)
	ld	hl,GAMEAREA_SCREEN0_ADR	;; hl = destino
	ld	bc,#4000		;; bc = numero de bytes
	xor	a			;; a = byte
	call	fillMem

	;; borra la pantalla (buffer 2)
	ld	hl,GAMEAREA_SCREEN1_ADR	;; hl = destino
	ld	bc,#4000		;; bc = numero de bytes
	call	fillMem

	;; borra el mapeado de tiles de la pantalla
	ld	hl,DECOMP_TILE_MAP	;; hl = destino
	ld	bc,DECOMP_TILE_MAP_SIZE	;; bc = numero de bytes
	call	fillMem

	;; prepara variables y automodificacion de codigo

	ld	hl,DECOMP_TILE_MAP
	ld	(decompTileMap_adr),hl

	call	doubleBuffer_tileMap_ready

	pop	hl			;; recupera el desplazamiento de pantalla


;	push	hl
;	call	refresh_scroll_q2
;	pop	hl

;	ld	b,GAMEAREA_W
;__loop
;	push	bc
;	push	hl

;	ld	hl,(_counterFrame+1)
;	inc	hl
;	ld	(_counterFrame + 1),hl

;	call	setScrollValues	;	call	processScroll
;	pop	hl

;	push	hl
;	call	refresh_scroll_q2
;	pop	hl

;	ld	de,4
;	add	hl,de

;	pop	bc
;	djnz	__loop

;	ret

	push	hl
	ld	de,GAMEAREA_SCREEN0_ADR	;; DE = posicion en pantalla
;	add	hl,de
;	ex	hl,de
;	ld	hl,(tileMap_adr)	;; HL = posicion en tileMap

;	call	drawTileMapScreen
	call	myDrawTileMapScreen

	pop	hl
	ld	de,GAMEAREA_SCREEN1_ADR	;; DE = posicion en pantalla

myDrawTileMapScreen
	add	hl,de
	ex	hl,de
	ld	hl,(tileMap_adr)	;; HL = posicion en tileMap

	;; Dibuja una pantalla completa de tiles (5,5 frames aprox) -----------

	;; HL = posicion en tileMap
	;; DE = posicion en pantalla

drawTileMapScreen
	inc	l				;; salta codigo de enemigos

	ld	iyh,GAMEAREA_W

	exx
	ld	bc,(decompTileMap_adr)

	ld	hl,DECOMP_TILE_RIGHT_COLUMN_OFFSET + 1
	add	hl,bc				;; HL = la siguiente columna de BC para que no de problemas el aprovechamiento de la morralla
	ld	(_drawTileMapScreen_hl + 1),hl

	exx

drawTileMapScreen_loop
	push	de
	push	hl

	call	drawTileMapColumn

	ld	a,DECOMP_TILE_MAP_H		;; siguiente columna
	add	c
	ld	c,a
	jr	nc,$+5
	inc	b
	res	3,b
	ld	a,c				;; desde el tile de arriba
	and	#ff - DECOMP_TILE_MAP_H + 1	
	ld	c,a

_drawTileMapScreen_hl
	ld	hl,0				;; HL = la siguiente columna de BC para que no de problemas el aprovechamiento de la morralla

	exx

	pop	hl

	ld	de,TILEMAP_COLUMN_LEN
	add	hl,de

;	repeat	TILEMAP_COLUMN_LEN-2
;	inc	l				;; siguiente columna en el mapeado
;	rend
;	inc	hl
;	inc	l

	IF	LOOP_TILEMAP
	call	adjustTileMapColumnRight
	ENDIF

	pop	de

	NEXT_TILE_COLUMN		; 5c

	dec	iyh
	jr	nz,drawTileMapScreen_loop

	ret

	;; Devuelve una posicion en el mapeado de tiles en funcion de un desplazamiento

	;; Entrada:
	;;	BC = desplazamiento (h_scroll_pos)

	;; Salida:
	;;	HL = posicion en tileMap
	;;	BC = desplazamiento en pantalla

getTileMapPos

_myTileMap2
	ld	hl,tileMap		; posicion en tileMap

	ld	a,c
	sra	b
	rra
	sra	b
	rra
	ld	c,a
	or	b
	ret	z

	bit	7,b
	jr	z, getTileMapPos_positive

	ex	hl,de
_myTileMapColumnLen2
	ld	hl,n_tileMap_columns
	add	hl,bc
	LD______BC_HL
	ex	hl,de
getTileMapPos_positive

	push	bc

getTileMapPos_loop
	repeat	TILEMAP_COLUMN_LEN
	inc	hl
	rend

	IF	LOOP_TILEMAP
	call	adjustTileMapColumnRight; HL = posicion en tileMap
	ENDIF

	dec	bc
	ld	a,b
	or	c
	jr	nz, getTileMapPos_loop

	pop	bc

	sla	c
	ld	a,b
	adc	a
	and	%0111
	ld	b,a

	ret

	;; Actualiza el mapeado segun el scroll

	;; Entrada:
	;;	AF' = indica si debe dibujar la columna de la izq o der

updateTileMap

	;; comprueba si debe dibujar la anterior columna en este buffer de pantalla

_updateTileMap_repeat
	jr	_required_updateTileMap

	;; dibuja la columna de tiles repetida en el otro buffer de pantalla del doble buffer

_repeated_drawTileMap_hl_p
	ld	hl,0
_repeated_drawTileMap_bc
	ld	bc,0
	exx
_repeated_drawTileMap_hl
	ld	hl,0				;; HL = posicion en tileMap
_repeated_drawTileMap_de
	ld	de,0
	ld	a,d
	xor	GAMEAREA_SCREEN_SW / #100
	ld	d,a				;; DE = posicion en pantalla

	inc	l				;; salta codigo de enemigos

_repeated_drawTileMap_call
	call	drawTileMapColumn		;; OJO!, esto no puede pisar AF'

	call	doubleBuffer_tileMap_ready	;; desactiva la repeticion del dibujado de la columna para el siguiente frame

_required_updateTileMap
	ex	af,af'
	ret	z

	;; debe dibujar una columna

	ld	hl,(tileMap_adr)

	or	a
	jr	nz, update_back_map_column

	;; dibuja columna de la derecha

	;;	[A]BCDEFGH -> BCDEFGH(I)
	;;	(I)JKLMNOP -> JKLMNOP(Q)
	;;	(Q)RSTUVWX -> RSTUVWX[A]

	repeat	TILEMAP_COLUMN_LEN
	inc	hl
	rend

	IF	LOOP_TILEMAP
	call	adjustTileMapColumnRight	;; HL = posicion en tileMap
	ENDIF

	ld	(tileMap_adr),hl		;; guarda la nueva posicion

	ld	de,GAMEAREA_W - 1 * TILEMAP_COLUMN_LEN
	add	hl,de

	IF	LOOP_TILEMAP
	call	adjustTileMapColumnRight	;; HL = posicion en tileMap
	ENDIF

	ex	hl,de
	ld	hl,(screen_adr)
	ld	bc,GAMEAREA_W_BYTE-2
	add	hl,bc
	res	3,h				;; se asegura que no se salga de los primeros #800 bytes del banco de pantalla (ya que screen_adr va de #c000 a #c7ff)
	ex	hl,de				;; DE = posicion en pantalla

	exx

	;; avanza en el buffer descomprimido del mapeado
	ld	de,(decompTileMap_adr)
	ld	hl,DECOMP_TILE_MAP_H
	add	hl,de
	res	3,h
	ld	(decompTileMap_adr),hl

	;; lo lleva a la columna de la derecha
	ld	bc,DECOMP_TILE_RIGHT_COLUMN_OFFSET - DECOMP_TILE_MAP_H	;; valor que se suma a (decompTileMap_adr) para tener el puntero a la columna de la der
	add	hl,bc
	res	3,h
	ld	(_repeated_drawTileMap_bc + 1),hl
	ld	b,h				;; BC' = posicion en la pantalla de tiles
	ld	c,l

	ex	hl,de
	inc	l				;; HL' = posicion en la pantalla de tiles (linea de la columna inversa con morralla)

	ld	(_repeated_drawTileMap_hl_p + 1),hl

	exx

	;; en el siguiente frame dibujara la misma columna en el otro buffer de pantalla

	ld	(_repeated_drawTileMap_hl + 1),hl
	ld	(_repeated_drawTileMap_de + 1),de
	xor	a
	ld	(_updateTileMap_repeat + 1),a		;; activa la repeticion del dibujado de la columna para el siguiente frame

	;; comprueba codigo de enemigos

	ld	a,(hl)
	or	a
	ld	c,GAMEAREA_W_PIXEL			;; derecha
	call	nz, onTileMapCommand
	inc	l

	call	drawTileMapColumn_right

	ld	hl,drawTileMapColumn_right
	ld	(_repeated_drawTileMap_call + 1),hl

	ret

update_back_map_column

	;; dibuja columna de la izquierda

	;;	ABCDEFG(H) -> [X]ABCDEFG
	;;	IJKLMNO(P) -> (H)IJKLMNO
	;;	QRSTUVW[X] -> (P)QRSTUVW

	repeat	TILEMAP_COLUMN_LEN
	dec	hl
	rend

	IF	LOOP_TILEMAP
	call	adjustTileMapColumnLeft		;; HL = posicion en tileMap
	ENDIF

	ld	(tileMap_adr),hl
	ld	de,(screen_adr)			;; DE = posicion en pantalla

	exx

	ld	hl,(decompTileMap_adr)
	ld	bc,DECOMP_TILE_LEFT_COLUMN_OFFSET	;; valor que se suma a (decompTileMap_adr) para tener el puntero a la columna de la izq
	add	hl,bc
	res	3,h
	ld	(decompTileMap_adr),hl
	ld	(_repeated_drawTileMap_bc + 1),hl
	ld	b,h				;; BC' = posicion en la pantalla de tiles
	ld	c,l

	ld	de,DECOMP_TILE_RIGHT_COLUMN_OFFSET
	add	hl,de
	res	3,h				;; HL' = posicion en la pantalla de tiles (linea de la columna inversa con morralla)

	ld	(_repeated_drawTileMap_hl_p + 1),hl

	exx

	;; en el siguiente frame dibujara la misma columna en el otro buffer de pantalla

	ld	(_repeated_drawTileMap_hl + 1),hl
	ld	(_repeated_drawTileMap_de + 1),de
	xor	a
	ld	(_updateTileMap_repeat + 1),a		;; activa la repeticion del dibujado de la columna para el siguiente frame

	;; comprueba codigo de enemigos

	ld	a,(hl)
	or	a
	ld	c,0					;; izq
	call	nz, onTileMapCommand
	inc	l

	call	drawTileMapColumn_left

	ld	hl,drawTileMapColumn_left
	ld	(_repeated_drawTileMap_call + 1),hl

	ret

	;; Inicializa el double buffer en el tileMap

doubleBuffer_tileMap_ready
	ld	a,_required_updateTileMap - _updateTileMap_repeat - 2
	ld	(_updateTileMap_repeat + 1),a		;; desactiva la repeticion del dibujado de la columna para el siguiente frame

	ret

	IF	LOOP_TILEMAP

	;; Ajusta la direccion de la columna del tileMap por la derecha -----------------------

	;; HL = posicion en tileMap

adjustTileMapColumnRight
	ex	hl,de
_myTileMapEnd1i
	ld	hl,-tileMap_end
	add	hl,de
	ex	hl,de
	ret	nc
_myTileMapLen2i
	ld	de,-tileMap_len
	add	hl,de
	ret

	;; Ajusta la direccion de la columna del tileMap por la izquierda ---------------------

	;; HL = posicion en tileMap

adjustTileMapColumnLeft
	ex	hl,de
_myTileMapEnd2i
	ld	hl,-tileMap_end + tileMap_len
	add	hl,de
	ex	hl,de
	ret	c
_myTileMapLen1
	ld	de,tileMap_len
	add	hl,de
	ret

	ENDIF

	;; Dibuja una columna de tiles por la izq (2200c aprox) ---------------------------

	;;		ABCDEFG(H) -> [X]ABCDEFG	* Para el primer tile no debe comprobar si estaba bien puesto
	;;		IJKLMNO(P) -> (H)IJKLMNO
	;;		QRSTUVW[X] -> (P)QRSTUVW

	;; HL = posicion en tileMap
	;; DE = posicion en pantalla
	;; BC' = posicion en la pantalla de tiles (linea que va a dibujar)
	;; HL' = posicion en la pantalla de tiles (linea de la columna inversa con morralla)

drawTileMapColumn_left
	ld	bc,GAMEAREA_W_BYTE * #100 + #ff
	ld	iyl,TILECOLUMN_SUBMAP_0_LEN

	ld	a,(hl)
	inc	l
	push	hl
	exx
	ld	de,tileSubMap0_ptr

	;; primer tile sin comprobacion de aprovechamiento de morralla

	ADD_____DE_2A

	ex	hl,de
	ld	a,(hl)
	inc	l
	ld	h,(hl)
	ld	l,a
	ex	hl,de

	ld	a,(de)

	ld	(bc),a			;;	guarda el id del tile en el buffer del mapeado
	inc	c

	exx

	call	drawTileSubMapColumn_tile_dirty

	exx

	ld	iyl,TILECOLUMN_SUBMAP_1_LEN

	pop	hl
	ld	a,(hl)
	inc	l
	push	hl

	exx

	ld	de,tileSubMap1_ptr
	call	drawTileSubMapColumn

	exx

	ld	iyl,TILECOLUMN_SUBMAP_2_LEN

	pop	hl
	ld	a,(hl)

	exx

	ld	de,tileSubMap2_ptr

	;; Dibuja un subtrozo de mapa de columna

drawTileSubMapColumn

	ADD_____DE_2A

	ex	hl,de
	ld	a,(hl)
	inc	l
	ld	h,(hl)
	ld	l,a
	ex	hl,de

drawTileSubMapColumn_loop
	ld	a,(de)
	ld	(bc),a				;; guarda el id del tile en el buffer del mapeado
	inc	c

	cp	(hl)
	inc	hl				;; OJO!, debe ser HL para no joder la bandera Z

	exx

	jr	nz, drawTileSubMapColumn_tile_dirty

	;; se ahorra dibujar el tile porque es el mismo que ya estaba como morralla

	NEXT_TILE_ROW

	exx
	inc	de
	dec	iyl
	jr	nz, drawTileSubMapColumn_loop

	ret

drawTileSubMapColumn_tile_dirty
	or	a
	jr	z, drawBlankTile		;; dibuja el tile en blanco

	ld	h,tilesAdr_l / #100		;; version optimizada con tabla
	ld	l,a
	ld	a,(hl)
	inc	h
	ld	h,(hl)
	ld	l,a

	;; Dibuja un tile (99c)

	;; HL = direccion del tile
	;; DE = direccion de pantalla

	DRAW_TILE

	NEXT_TILE_ROW

	exx
	inc	de
	dec	iyl
	jr	nz, drawTileSubMapColumn_loop

	ret

	;; Dibuja un tile en blanco (OPTIMIZACION) (63c)

	;; DE = direccion de pantalla
	
drawBlankTile
	DRAW_BLANK_TILE

	NEXT_TILE_ROW

	exx
	inc	de
	dec	iyl
	jp	nz, drawTileSubMapColumn_loop

	ret

	;; Dibuja una columna de tiles por la derecha (2200c aprox) ---------------------------

	;;		[A]BCDEFGH -> BCDEFGH(I)
	;;		(I)JKLMNOP -> JKLMNOP(Q)
	;;		(Q)RSTUVWX -> RSTUVWX[A]	* Para el ultimo tile no debe comprobar si estaba bien puesto

	;; HL = posicion en tileMap
	;; DE = posicion en pantalla
	;; BC' = posicion en la pantalla de tiles (linea que va a dibujar)
	;; HL' = posicion en la pantalla de tiles (linea de la columna inversa con morralla)

drawTileMapColumn
drawTileMapColumn_right
	ld	bc,GAMEAREA_W_BYTE * #100 + #ff		;; B = GAMEAREA_W_BYTE
	ld	iyl,TILECOLUMN_SUBMAP_0_LEN

	ld	a,(hl)
	inc	l
	push	hl

	exx
	ld	de,tileSubMap0_ptr
	call	drawTileSubMapColumn

	exx

	ld	iyl,TILECOLUMN_SUBMAP_1_LEN

	pop	hl
	ld	a,(hl)
	inc	l
	push	hl

	exx

	ld	de,tileSubMap1_ptr
	call	drawTileSubMapColumn

	exx

	ld	iyl,TILECOLUMN_SUBMAP_2_LEN - 1

	pop	hl
	ld	a,(hl)

	exx

	ld	de,tileSubMap2_ptr
	call	drawTileSubMapColumn

	;; ultimo tile sin comprobacion de aprovechamiento de morralla

	ld	a,(de)

	ld	(bc),a				;; guarda el id del tile en el buffer del mapeado
	inc	c

	exx
	inc	iyl

	jp	drawTileSubMapColumn_tile_dirty


	;; SOPORTE DE BORRADO DE RECTANGULOS DE TILES SUCIOS ----------------------------------------

clearDirtyBlankTile
	DRAW_BLANK_TILE

	NEXT_TILE_ROW

	exx
	
	djnz	clearDirtyTilesRect_height_loop

	jp	clearDirtyTilesRect_continue

	;; Borra rectangulos de tiles sucios

	;; 78/138c por tile + 32c por columna + 22c por sprite

clearDirtyTilesRect

_clearSprite_nDirtyTilesRect
	ld	hl,0
	ld	a,(hl)
	or	a
	ret	z			;; si no tiene retorna

	ld	(hl),0
	ld	iyh,a			;; iyh = numero de sprites que hay que borrar (1 por sprite que se dibujo o grupo de tiles de animacion, para tiles sueltos de animacion seria otra rutina)

	ld	bc,GAMEAREA_W_BYTE * #100 + #ff		;; OJO!, C = #ff para que el ldi no reste B
	exx

	ld	(_clearDirtyTilesRect_sp_bak + 1),sp

_clearSprite_myDirtyTilesRect1
	ld	sp,(0)			;; SP = puntero a info de rectangulo de tiles que debe borrar, no importa que una interrupcion pise el contenido de SP porque solo se usa para leer hacia arriba

clearDirtyTilesRect_sprite_loop

	;; SP = puntero a info del rectangulo de tiles que hay que borrar

	;; (sp + 0) .w = posicion del tile de la esquina superior izquierda en DECOMP_TILE_MAP
	;; (sp + 2) .b = w
	;; (sp + 3) .b = h
	;; (sp + 4) .w = posicion en pantalla

	pop	hl			;; HL = posicion del tile de la esquina superior izquierda en DECOMP_TILE_MAP
	pop	bc			;; B = height , C = width

	ld	iyl,c			;; IYL = width
	ld	c,b			;; guarda height en C

	exx

	pop	de			;; DE' = posicion en pantalla (a nivel de byte)

;	res	0,e
;	ld	a,d
;	and	%11000111
;	ld	d,a			;; DE' = posicion en pantalla (a nivel de tile)
	
clearDirtyTilesRect_width_loop
	push	de

	exx

	ld	d,h
	ld	e,l

clearDirtyTilesRect_height_loop
	ld	a,(hl)
	inc	l

	exx

	or	a
	jr	z, clearDirtyBlankTile	;; dibuja el tile en blanco

	ld	h,tilesAdr_l / #100	;; version optimizada con tabla
	ld	l,a
	ld	a,(hl)
	inc	h
	ld	h,(hl)
	ld	l,a

	;; Dibuja un tile

	;; HL = direccion del tile
	;; DE = direccion de pantalla

	DRAW_TILE

	NEXT_TILE_ROW

	exx
	
	djnz	clearDirtyTilesRect_height_loop

clearDirtyTilesRect_continue
	ld	hl,DECOMP_TILE_MAP_H	;; siguiente columna en DECOMP_TILE_MAP (32)
	add	hl,de
	res	3,h

	ld	b,c

	exx

	pop	de			;; recupera la posicion en pantalla del tile de arriba
	NEXT_TILE_COLUMN

	dec	iyl
	jr	nz, clearDirtyTilesRect_width_loop

	ld	c,#ff			;; se asegura que no llegue a 0
	exx

	dec	iyh
	jp	nz, clearDirtyTilesRect_sprite_loop

_clearSprite_myDirtyTilesRect2
	ld	(0),sp			;; sp = puntero a info de rectangulo de tiles que debe borrar

_clearDirtyTilesRect_sp_bak
	ld	sp,0

	ret

	;; Anyade un rectangulo de tiles sucios

	;; A  = H
	;; A' = W
	;; BC = posicion en pantalla
	;; DE = posicion del tile de la esquina superior izquierda en DECOMP_TILE_MAP

addDirtyTilesRect

	;; incrementa el numero de rectangulos de tile sucios

_add_nDirtyTilesRect
	ld	hl,0
	inc	(hl)

	;; guarda los datos del rectangulo sucio

_add_myDirtyTilesRect1
	ld	hl,(0)
	dec	hl

	ld	(hl),b
	dec	l
	ld	(hl),c

	;; ( + 4) .w = posicion en pantalla

	dec	hl
	ld	(hl),a

	;; ( + 3) .b = h

	dec	l
	ex	af,af'
	ld	(hl),a

	;; ( + 2) .b = w

	dec	hl
	ld	(hl),d
	dec	l
	ld	(hl),e

	;; ( + 0) .w = posicion del tile de la esquina superior izquierda en DECOMP_TILE_MAP

_add_myDirtyTilesRect2
	ld	(0),hl

	ret

	;; Anyade un rectangulo de tiles sucios en el otro buffer del double buffer

addDirtyTilesRect_doubleBuffer
_add_myDirtyTilesRect_repeat1
	ld	hl,(0)
	dec	hl

	ld	(hl),b
	ld	b,a
	ld	a,(hl)
	xor	%01000000
	ld	(hl),a
	dec	l
	ld	(hl),c

	;; ( + 4) .w = posicion en pantalla

	dec	hl
	ex	af,af'
	ld	(hl),a

	;; ( + 3) .b = h

	dec	l
	ld	(hl),b

	;; ( + 2) .b = w

	dec	hl
	ld	(hl),d
	dec	l
	ld	(hl),e

_add_myDirtyTilesRect_repeat2
	ld	(0),hl

_add_nDirtyTilesRect_repeat
	ld	hl,0
	inc	(hl)

	ret

	;; Callback para gestionar comandos (enemigos) del mapeado
	;; (para poner enemigos o cambios de color del mapeado)

	;;  C = 0 = izq, GAMEAREA_W_PIXEL = der
	;; HL = posicion en tileMap
	;; DE = posicion en pantalla (arriba)
	;; BC' = posicion en la pantalla de tiles (linea que va a dibujar)
	;; HL' = posicion en la pantalla de tiles (linea de la columna inversa con morralla)

onTileMapCommand

	IF	DINAMIC_PALETTE_CHANGES

	cp	DINAMIC_PALETTE_CHANGES
	jr	nc, changeTileMapPalette

	ENDIF

	;; enemigos

	bit	0,a
	ret	nz		;; si ya esta puesto no pone otro

	push	ix

	set	0,(hl)		;; lo marca como puesto

	ld	b,0		;; BC = coordenada X relativa donde debe poner el enemigo (0 / GAMEAREA_W_PIXEL)

	push	hl
	push	de
	ex	hl,de		;; DE = puntero a guardar en enemy_gTileMap_adr_off

;	exx
;	pop	de
;	push	de		;; DE' = posicion en pantalla (arriba)
;	exx

	;; llama al metodo que crea el enemigo especificado

	ld	hl,createEnem_back
	push	hl

	ld	hl,createEnemList
	and	%01111110
	ADD_____HL_A
	ld	a,(hl)
	inc	l
	ld	h,(hl)
	ld	l,a
	jp	(hl)		;; OJO!, esta llamada debe conservar
				;; HL = posicion en tileMap
				;; DE = posicion en pantalla
				;; BC' = posicion en la pantalla de tiles (linea que va a dibujar)
				;; HL' = posicion en la pantalla de tiles (linea de la columna inversa con morralla)
createEnem_back
	pop	de
	pop	hl

	pop	ix

	ret

	IF	DINAMIC_PALETTE_CHANGES

	;; Cambios de paleta del mapeado

changeTileMapPalette
	ld	(_nextMapColors + 1),a
	ret

	;; Actualiza los colores del mapeado (si hubo algun cambio)

refreshMapColors
_nextMapColors
	ld	a,0
	or	a
	ret	z

	sub	DINAMIC_PALETTE_CHANGES

	add	a			;; x2 (y bit 7 = 0)
	ld	hl,myMap_colors
	ADD_____HL_A

	xor	a
	ld	(_nextMapColors + 1),a

	ld	a,(hl)
	inc	l
	ld	h,(hl)
	ld	l,a

	jp	(hl)

	ENDIF

	;; DATOS =========================================================

	LIST

tileMap_adr		dw	0			;; puntero a la posicion inicial en el mapeado de tiles del nivel
decompTileMap_adr	dw	0			;; puntero a la posicion inicial en el mapeado de tiles decomprimido (pantalla actual)

			;; rectangulo de tiles sucios para el borrado de sprites y animacion de tiles

nDirtyTilesRect0	db	0			;; numero de rectangulos de tiles sucios (frame par del double buffer)
dirtyTilesRect0_adr	dw	dirty_tiles_rect0	;; puntero al final de la lista de rectangulos de tiles sucios (frame par del double buffer)
nDirtyTilesRect1	db	0			;; numero de rectangulos de tiles sucios (frame par del double buffer)
dirtyTilesRect1_adr	dw	dirty_tiles_rect1	;; puntero al final de la lista de rectangulos de tiles sucios (frame impar del double buffer)

	NOLIST
