
	;; =========================================================================
	;; MAPEADO DE PRUEBA
	;; =========================================================================

	;; * En el ejemplo se define a mano, pero lo ideal es usar un editor de mapeados y hacer una 
	;;   herramienta que lo convierta a este formato.

	;; * Tiles de 4x8 pixeles de mode 0 (1 caracter)

	;; * El mapeado se define comprimido por columnas, cada una con 1 byte para definir enenmigos + 3
	;;   subcolumnas para las distintas franjas de color (las 2 franjas de abajo se definen en la misma
	;;   subcolumna)

	;; * Si el byte que define enemigos es >= DINAMIC_PALETTE_CHANGES, se refiere a un cambio de paleta
	;;   en el mapeado para hacer que las distintas franjas no siempre sean de los mismos colores.
	;;   Si es < DINAMIC_PALETTE_CHANGES es el ID de un enemigo (el bit 0 indica si el enemigo esta ya
	;;   puesto). Si el byte es 0 no se pone nada. Para definir la posicion de salida de los enemigos
	;;   en el mismo byte, se definen IDs de enemigos diferentes dependiende de la posicion de salida.

	;; * En DECOMP_TILE_MAP se guarda la informacion del mapeado descomprimido de la pantalla actual, ya 
	;;   que el mapa esta comprimido en submapas. Estos datos descomprimidos se usan para detectar
	;;   colisiones de tiles, borrar sprites dibujando tiles, etc... El buffer se compone de 64x32 tiles
	;;   al redondear a potencias de 2 las dimensiones (14 tiles mas que el area visible a lo ancho y 12 a
	;;   lo alto, aunque por ahora solo se utiliza el area visible). 

	;; * Tiles con ID >= 128 colisionan

	LIST

	ALIGN	TILE_LEN
tiles
	NOLIST

	incbin "resources\tiles_nc.bin"

	ORGF	#80 * TILE_LEN + tiles, 0

	incbin "resources\tiles_c.bin"

	;; mapeado (cada linea de codigo corresponde con una columna)

	ALIGN	4

tileMap
	;;	enemigo, 	franja superior, intermedia,	baja
	db	0,	 	0,  	     	0,  		3
	db	0,	 	1 + MBOT0,  	0,  		4
	db	0,	 	2 + MBOT0,  	0,  		5
	db	0, 		3 + MBOT0,  	0,  		6
	db	0,		4 + MBOT0,  	0,  		7
	db	0, 		5 + MBOT0,  	1 + MBOT1,  	2
	db	0,	 	6 + MBOT0,  	6 + MBOT1,  	8
	db	0,	 	7 + MBOT0,  	7 + MBOT1,  	9
	db	0,	 	8 + MBOT0,  	6 + MBOT1,  	47
	db	0,	 	9 + MBOT0,  	7 + MBOT1,  	48
	db	0,	 	0,  	     	3 + MBOT1, 	49
	db	0,	 	0,  		0, 		50
	db	0,	 	0,  		0, 		51
	db	0,	 	0,  		0, 		13
	db	0,		1 + MTOP0, 	0, 		1
	db	0,		2 + MTOP0,  	1 + MBOT1,  	2
	db	0,		3 + MTOP0,  	2 + MBOT1,  	1
	db	0,		4 + MTOP0,  	5 + MBOT1,  	2
	db	0,		5 + MTOP0,  	8 + MBOT1,  	1
	db	0,		6 + MTOP0,  	9 + MBOT1,  	2
	db	0,		3 + MTOP0,  	2 + MBOT1,  	1
	db	0,		4 + MTOP0,  	4 + MBOT1,  	2
	db	0,		5 + MTOP0,  	4 + MBOT1,  	3
	db	0,		6 + MTOP0,  	4 + MBOT1,  	4
	db	0,		7 + MTOP0,  	4 + MBOT1,  	5
	db	0,		8 + MTOP0,  	5 + MBOT1,  	6
	db	0,		9 + MTOP0,  	6 + MBOT1,  	7
	db	0,	 	1 + MBOT0,  	7 + MBOT1,  	2
	db	0,	 	2 + MBOT0,  	2 + MBOT1,  	1
	db	0,	 	3 + MBOT0,  	5 + MBOT1,  	2
	db	0,	 	4 + MBOT0,  	3 + MBOT1,  	8
	db	0,	 	5 + MBOT0,  	0,  		9
	db	0,	 	6 + MBOT0,  	0,  		10
	db	0,	 	7 + MBOT0,  	0,  		11
	db	0,	 	8 + MBOT0,  	0,  		12
	db	0,	 	9 + MBOT0,  	0,  		13
	db	0,	 	0,  		0,  		1
	db	0,	 	0,  		0,  		2
	db	0,	 	0,  		0, 		15 + MPIPES
	db	0,	 	0,  		0, 		16 + MPIPES
	db	0,	 	0,  		0, 		17 + MPIPES
	db	0,	 	0,  		0, 		18 + MPIPES
	db	0,	 	0,  		0, 		19 + MPIPES
	db	0,	 	0,  		0,  		2
	db	0,	 	0,  		0,  		1
	db	0,	 	0,  		1 + MTOP1,  	2
	db	0,	 	0,  		2 + MTOP1,  	1
	db	0,	 	0,  		4 + MTOP1,  	2
	db	0,	 	0,  		4 + MTOP1,  	1
	db	0,	 	0,  		4 + MTOP1,  	2
	db	0,	 	0,  		5 + MTOP1,  	1
	db	BIRD_HI_ID,	0,  		3 + MTOP1,  	2
	db	0,		1 + MTOP0,  	0,  		1
	db	COIN_ROW06_ID,	2 + MTOP0,  	0,  		2
	db	0,	 	3 + MTOP0,  	0,  		1
	db	0,	 	4 + MTOP0,  	0,  		2
	db	COIN_ROW06_ID,	5 + MTOP0,  	0,  		1
	db	0,	 	6 + MTOP0,  	0,  		2
	db	0,	 	3 + MTOP0,  	0,  		1
	db	COIN_ROW06_ID,	4 + MTOP0,  	0,  		2
	db	0,	 	5 + MTOP0,  	0,  		1
	db	0,	 	6 + MTOP0,	0, 		2
	db	COIN_ROW06_ID,	7 + MTOP0,	0, 		15 + MPIPEXS
	db	TURTLE_HI_ID, 	8 + MTOP0,	0, 		16 + MPIPEXS
	db	0,		9 + MTOP0,	0, 		17 + MPIPEXS
	db	0,	 	0,  		1 + MTOP1,  	18 + MPIPEXS
	db	0,	 	0,  		2 + MTOP1,  	19 + MPIPEXS
	db	0,	 	1 + MBOT0,	4 + MTOP1,  	2
	db	0,	 	2 + MBOT0,	4 + MTOP1,  	15 + MPIPES
	db	0,	 	3 + MBOT0,	4 + MTOP1,  	16 + MPIPES
	db	0,	 	4 + MBOT0,	5 + MTOP1,  	17 + MPIPES
	db	0,	 	5 + MBOT0,	3 + MTOP1,  	18 + MPIPES
	db	0,	 	6 + MBOT0,	0,  		19 + MPIPES
	db	0,	 	7 + MBOT0,	0,  		2
	db	0,	 	8 + MBOT0,	0,  		15 + MPIPEL
	db	0,	 	9 + MBOT0,	0,  		16 + MPIPEL
	db	0,	 	0,  		0, 		17 + MPIPEL
	db	0,	 	0,  		0, 		18 + MPIPEL
	db	MPAL01,	 	0,  		0, 		19 + MPIPEL
	db	0,	 	0,  		0, 		2
	db	0,	 	0,  		1 + MMID1,  	1
	db	0,	 	0,  		2 + MMID1,  	2
	db	0,	 	0,  		5 + MMID1,  	1
	db	0,	 	1 + MTOP0,	6 + MMID1,  	2
	db	0,	 	2 + MTOP0,	7 + MMID1,  	1
	db	0,	 	3 + MTOP0,	2 + MMID1,  	2
	db	0,	 	4 + MTOP0, 	5 + MMID1,  	1
	db	0,	 	5 + MTOP0,	3 + MMID1,  	2
	db	0,	 	6 + MTOP0,	0,  		1
	db	0,	 	3 + MTOP0,	1 + MBOT1,	2
	db	0,	 	4 + MTOP0,	2 + MBOT1,  	1
	db	0,	 	5 + MTOP0,	5 + MBOT1,  	2
	db	0,	 	6 + MTOP0,	8 + MBOT1,  	1
	db	0,	 	7 + MTOP0,	9 + MBOT1,  	2
	db	0,	 	8 + MTOP0,	2 + MBOT1,  	1
	db	0,	 	9 + MTOP0,	5 + MBOT1,  	2
	db	0,	 	0,  		3 + MBOT1,  	1
	db	0,	 	0,  		0,  		2
	db	0,	 	0,  		0,  		1
	db	0,	 	0,  		0,  		2
	db	0, 		0,  		0,  		1
	db	0, 		0,  		1 + MTOP1,	2
	db	COIN_ROW10_ID,	0,  		2 + MTOP1,  	1
	db	0, 		0,  		5 + MTOP1,  	2
	db	0,	 	0,  		8 + MTOP1,  	1
	db	COIN_ROW10_ID, 	0,  		9 + MTOP1,  	2
	db	0,	 	0,  		2 + MTOP1,  	1
	db	0,	 	0,  		4 + MTOP1,  	2
	db	COIN_ROW10_ID, 	0,  		4 + MTOP1,  	1
	db	0, 		0,  		4 + MTOP1,  	2
	db	0,	 	0,  		4 + MTOP1,  	1
	db	COIN_ROW10_ID, 	0,  		4 + MTOP1,  	2
	db	0,		0,		4 + MTOP1,  	1
	db	BIRD_HI_ID,	1 + MBOT0,  	4 + MTOP1,  	2
	db	COIN_ROW10_ID, 	2 + MBOT0,	5 + MTOP1,  	1
	db	0, 		3 + MBOT0,  	8 + MTOP1,  	2
	db	0,	 	4 + MBOT0,  	9 + MTOP1,  	1
	db	COIN_ROW10_ID, 	5 + MBOT0,	2 + MTOP1,  	2
	db	0, 		6 + MBOT0,	5 + MTOP1,  	1
	db	0,	 	7 + MBOT0,	3 + MTOP1,  	2
	db	0,	 	8 + MBOT0,	0,  		1
	db	0,	 	9 + MBOT0,	0,  		2
	db	0,	 	0,  		1 + MBOT1,	1
	db	0,	 	0,  		8 + MBOT1,	2
	db	0,	 	0,  		9 + MBOT1,	1
	db	0,	 	0,  		8 + MBOT1,	2
	db	0,	 	1 + MTOP0,  	9 + MBOT1,	1
	db	0,	 	2 + MTOP0,  	3 + MBOT1,	2
	db	0,		3 + MTOP0,  	0,  		1
	db	0,	 	4 + MTOP0,  	0,  		2
	db	MPAL00, 	5 + MTOP0,  	0,  		35
	db	COIN_ROW10_ID, 	6 + MTOP0,	0,  		36
	db	0,	 	7 + MTOP0,  	0,  		39
	db	COIN_ROW08_ID,	8 + MTOP0,	0,  		40
	db	0, 		9 + MTOP0,  	0,  		43
	db	COIN_ROW06_ID,	0,		0,  		44
	db	0,	 	1 + MBOT0,	0,  		45
	db	0, 		2 + MBOT0,	0,  		44
	db	COIN_ROW06_ID, 	3 + MBOT0,	0,  		45
	db	MPAL00,	 	4 + MBOT0,	0,  		44
	db	0, 		5 + MBOT0,	0,  		45
	db	0,		6 + MBOT0,	0,  		46
	db	0, 		3 + MBOT0,	0,  		1
	db	0, 		4 + MBOT0,	0,  		2
	db	0, 		5 + MBOT0,	0,  		1
	db	0,		6 + MBOT0,	0,  		2
	db	0, 		7 + MBOT0,  	0,  		1
	db	0, 		8 + MBOT0,  	0,  		2
	db	COIN_ROW10_ID,	9 + MBOT0,  	0,  		1
	db	0, 		0,  		0,  		2
	db	0,		0,  		0,  		1
	db	COIN_ROW10_ID, 	0,  		0,  		2
	db	0,		0,  		0,  		1
	db	0,		0,  		0,  		2
	db	COIN_ROW10_ID, 	1 + MTOP0,  	0,  		1
	db	0,		2 + MTOP0,  	0,  		2
	db	0, 		3 + MTOP0,  	0,  		1
	db	COIN_ROW10_ID, 	4 + MTOP0,  	0,  		2
	db	0,		5 + MTOP0,  	0,  		1
	db	0, 		6 + MTOP0,  	0,  		2
	db	COIN_ROW10_ID, 	3 + MTOP0,  	0,  		1
	db	0,		4 + MTOP0,  	0,  		2
	db	0, 		5 + MTOP0,  	0,  		1
	db	COIN_ROW10_ID, 	6 + MTOP0,  	0,  		2
	db	0,		7 + MTOP0,  	0,  		1
	db	0, 		8 + MTOP0,  	0,  		2
	db	COIN_ROW10_ID, 	9 + MTOP0,  	0,  		1
	db	0,		1 + MBOT0,  	0,  		2
	db	0, 		2 + MBOT0,  	0,  		1
	db	COIN_ROW10_ID, 	3 + MBOT0,  	0,  		2
	db	0,		4 + MBOT0,  	0,  		1
	db	0, 		5 + MBOT0,  	0,  		2
	db	COIN_ROW10_ID, 	6 + MBOT0,  	0,  		1
	db	0,		7 + MBOT0,  	0,  		2
	db	0, 		8 + MBOT0,  	0,  		1
	db	COIN_ROW10_ID, 	9 + MBOT0,  	0,  		2
	db	0,		0,  		0,  		1
	db	0, 		0,  		0,  		2
	db	COIN_ROW10_ID, 	0,  		0,  		1
	db	0,		0,  		0,  		2
	db	0, 		0,  		0,  		1
	db	COIN_ROW10_ID, 	0,  		0,  		2
	db	0,		1 + MTOP0,	0,  		1
	db	0, 		2 + MTOP0,  	0,  		2
	db	COIN_ROW10_ID, 	3 + MTOP0,  	0,  		1
	db	0,		4 + MTOP0,  	0,  		2
	db	0, 		5 + MTOP0,  	0,  		1
	db	COIN_ROW10_ID,	6 + MTOP0,  	0,  		2
	db	0,		7 + MTOP0,  	0,  		1
	db	0, 		8 + MTOP0,  	0,  		2
	db	COIN_ROW10_ID,	9 + MTOP0,  	0,  		1
	db	0, 		0,  		0,  		2
	db	0, 		0,  		0,  		1
	db	COIN_ROW10_ID,	0,  		0,  		2
	db	0, 		0,  		0,  		1
	db	MPAL01,		0,  		0,  		2

tileMap_end
tileMap_len		EQU	tileMap_end - tileMap
n_tileMap_columns	EQU	tileMap_len / TILEMAP_COLUMN_LEN

	ALIGN	2

	;; Indices de subcolumnas (franja superior)

tileSubMap0_ptr
	dw	tileSubMap_void
	dw	0 * TILECOLUMN_SUBMAP_0_LEN + tileSubMap0
	dw	1 * TILECOLUMN_SUBMAP_0_LEN + tileSubMap0
	dw	2 * TILECOLUMN_SUBMAP_0_LEN + tileSubMap0
	dw	3 * TILECOLUMN_SUBMAP_0_LEN + tileSubMap0
	dw	4 * TILECOLUMN_SUBMAP_0_LEN + tileSubMap0
	dw	5 * TILECOLUMN_SUBMAP_0_LEN + tileSubMap0
	dw	6 * TILECOLUMN_SUBMAP_0_LEN + tileSubMap0
	dw	7 * TILECOLUMN_SUBMAP_0_LEN + tileSubMap0
	dw	8 * TILECOLUMN_SUBMAP_0_LEN + tileSubMap0
	dw	9 * TILECOLUMN_SUBMAP_0_LEN + tileSubMap0
	dw	10 * TILECOLUMN_SUBMAP_0_LEN + tileSubMap0
	dw	11 * TILECOLUMN_SUBMAP_0_LEN + tileSubMap0
	dw	12 * TILECOLUMN_SUBMAP_0_LEN + tileSubMap0
	dw	13 * TILECOLUMN_SUBMAP_0_LEN + tileSubMap0
	dw	14 * TILECOLUMN_SUBMAP_0_LEN + tileSubMap0
	dw	15 * TILECOLUMN_SUBMAP_0_LEN + tileSubMap0
	dw	16 * TILECOLUMN_SUBMAP_0_LEN + tileSubMap0
	dw	17 * TILECOLUMN_SUBMAP_0_LEN + tileSubMap0
	; ...

	;; Indices de subcolumnas (franja intermedia)

tileSubMap1_ptr
	dw	tileSubMap_void
	dw	0 * TILECOLUMN_SUBMAP_1_LEN + tileSubMap1
	dw	1 * TILECOLUMN_SUBMAP_1_LEN + tileSubMap1
	dw	2 * TILECOLUMN_SUBMAP_1_LEN + tileSubMap1
	dw	3 * TILECOLUMN_SUBMAP_1_LEN + tileSubMap1
	dw	4 * TILECOLUMN_SUBMAP_1_LEN + tileSubMap1
	dw	5 * TILECOLUMN_SUBMAP_1_LEN + tileSubMap1
	dw	6 * TILECOLUMN_SUBMAP_1_LEN + tileSubMap1
	dw	7 * TILECOLUMN_SUBMAP_1_LEN + tileSubMap1
	dw	8 * TILECOLUMN_SUBMAP_1_LEN + tileSubMap1
	dw	9 * TILECOLUMN_SUBMAP_1_LEN + tileSubMap1
	dw	10 * TILECOLUMN_SUBMAP_1_LEN + tileSubMap1
	dw	11 * TILECOLUMN_SUBMAP_1_LEN + tileSubMap1
	dw	12 * TILECOLUMN_SUBMAP_1_LEN + tileSubMap1
	dw	13 * TILECOLUMN_SUBMAP_1_LEN + tileSubMap1
	dw	14 * TILECOLUMN_SUBMAP_1_LEN + tileSubMap1
	dw	15 * TILECOLUMN_SUBMAP_1_LEN + tileSubMap1
	dw	16 * TILECOLUMN_SUBMAP_1_LEN + tileSubMap1
	dw	17 * TILECOLUMN_SUBMAP_1_LEN + tileSubMap1
	dw	18 * TILECOLUMN_SUBMAP_1_LEN + tileSubMap1
	dw	19 * TILECOLUMN_SUBMAP_1_LEN + tileSubMap1
	dw	20 * TILECOLUMN_SUBMAP_1_LEN + tileSubMap1
	dw	21 * TILECOLUMN_SUBMAP_1_LEN + tileSubMap1
	dw	22 * TILECOLUMN_SUBMAP_1_LEN + tileSubMap1
	dw	23 * TILECOLUMN_SUBMAP_1_LEN + tileSubMap1
	dw	24 * TILECOLUMN_SUBMAP_1_LEN + tileSubMap1
	dw	25 * TILECOLUMN_SUBMAP_1_LEN + tileSubMap1
	dw	26 * TILECOLUMN_SUBMAP_1_LEN + tileSubMap1
	dw	27 * TILECOLUMN_SUBMAP_1_LEN + tileSubMap1
	dw	28 * TILECOLUMN_SUBMAP_1_LEN + tileSubMap1
	dw	29 * TILECOLUMN_SUBMAP_1_LEN + tileSubMap1
	dw	30 * TILECOLUMN_SUBMAP_1_LEN + tileSubMap1
	dw	31 * TILECOLUMN_SUBMAP_1_LEN + tileSubMap1
	dw	32 * TILECOLUMN_SUBMAP_1_LEN + tileSubMap1
	; ...

	;; Indices de subcolumnas (franja inferior)

tileSubMap2_ptr
	dw	tileSubMap_void
	dw	 0 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	 1 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	 2 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	 3 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	 4 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	 5 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	 6 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	 7 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	 8 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	 9 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	10 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	11 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	12 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	13 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	14 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	15 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	16 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	17 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	18 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	19 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	20 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	21 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	22 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	23 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	24 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	25 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	26 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	27 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	28 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	29 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	30 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	31 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	32 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	33 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2

	dw	34 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	35 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	36 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	37 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2

	dw	38 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	39 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	40 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	41 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2

	dw	42 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	43 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	44 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	45 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2

	dw	46 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	47 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	48 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	49 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2
	dw	50 * TILECOLUMN_SUBMAP_2_LEN + tileSubMap2

	; ...

			;; tiles sin colision
PIPE_OUT_TILE_BASE	EQU	#2
WALL_OUT_TILE_BASE	EQU	#4
BUSH1_TILE_BASE		EQU	#6
BUSH2_TILE_BASE		EQU	#e
CLOUD_TILE_BASE		EQU	#1a
			;; tiles con colision
FLOOR_TILE_BASE		EQU	#80		; colision
PIPE_TILE_BASE		EQU	#84		; colision
WALL_TILE_BASE		EQU	#94		; colision

	;; Subcolumnas (franja superior)

MBOT0	EQU	0
MTOP0	EQU	9

tileSubMap0
	;; nube baja
	db	0,			0, 			0,			CLOUD_TILE_BASE+0, 	CLOUD_TILE_BASE+1	; 1
	db	0,			0, 			0,			CLOUD_TILE_BASE+2, 	CLOUD_TILE_BASE+3	; 2
	db	0,			0, 			CLOUD_TILE_BASE+4,  	CLOUD_TILE_BASE+5, 	CLOUD_TILE_BASE+6	; 3
	db	0,			0, 			CLOUD_TILE_BASE+7,  	CLOUD_TILE_BASE+8, 	CLOUD_TILE_BASE+9	; 4
	db	0,			0, 			CLOUD_TILE_BASE+10, 	CLOUD_TILE_BASE+8, 	CLOUD_TILE_BASE+11	; 5
	db	0,			0, 			CLOUD_TILE_BASE+12, 	CLOUD_TILE_BASE+13, 	CLOUD_TILE_BASE+14	; 6
	db	0,			0, 			0, 		 	CLOUD_TILE_BASE+15, 	CLOUD_TILE_BASE+16	; 7
	db	0,			0, 			0, 		 	CLOUD_TILE_BASE+17, 	CLOUD_TILE_BASE+18	; 8
	db	0,			0, 			0, 		 	CLOUD_TILE_BASE+19, 	CLOUD_TILE_BASE+20	; 9
	;; nube alta
	db	0,			CLOUD_TILE_BASE+0,	CLOUD_TILE_BASE+1,  	0,			0			; 10
	db	0,			CLOUD_TILE_BASE+2,	CLOUD_TILE_BASE+3,  	0,			0			; 11
	db	CLOUD_TILE_BASE+4,	CLOUD_TILE_BASE+5,	CLOUD_TILE_BASE+6,  	0,			0			; 12
	db	CLOUD_TILE_BASE+7,	CLOUD_TILE_BASE+8,	CLOUD_TILE_BASE+9,  	0,			0			; 13
	db	CLOUD_TILE_BASE+10,	CLOUD_TILE_BASE+8,	CLOUD_TILE_BASE+11, 	0,			0			; 14
	db	CLOUD_TILE_BASE+12,	CLOUD_TILE_BASE+13,	CLOUD_TILE_BASE+14, 	0,			0			; 15
	db	0,			CLOUD_TILE_BASE+15,	CLOUD_TILE_BASE+16, 	0,			0			; 16
	db	0,			CLOUD_TILE_BASE+17,	CLOUD_TILE_BASE+18, 	0,			0			; 17
	db	0,			CLOUD_TILE_BASE+19,	CLOUD_TILE_BASE+20, 	0,			0			; 18
	; ...

	;; Subcolumnas (franja intermedia)

MBOT1	EQU	0
MMID1	EQU	11
MTOP1	EQU	22

tileSubMap1	
	;; bajo
	db	0,			0,			0,			0,			0, 			WALL_OUT_TILE_BASE+0,	WALL_OUT_TILE_BASE+0	; 1	; ladrillo columna del borde izq de 1 pixel negro
	db	0,			0,			0,			0,			0, 			WALL_TILE_BASE+0,	WALL_TILE_BASE+1	; 2	; ladrillo columna pegada al borde izq de 1 pixel negro
	db	0,			0,			0,			0,			0, 			WALL_OUT_TILE_BASE+1,	WALL_OUT_TILE_BASE+1	; 3	; columna de cielo con 1 pixel negro a la izq
	db	0,			0,			0,			0,			0, 			WALL_TILE_BASE+2,	WALL_TILE_BASE+3	; 4	; ladrillo columna centro
	db	0,			0,			0,			0,			0, 			WALL_TILE_BASE+4,	WALL_TILE_BASE+5	; 5	; ladrillo columna der
	db	0,			0,			0,			0,			0, 			WALL_TILE_BASE+6,	WALL_TILE_BASE+7	; 6	; interrogante
	db	0,			0,			0,			0,			0, 			WALL_TILE_BASE+8,	WALL_TILE_BASE+9	; 7	; interrogante
	db	0,			0,			0,			0,			0, 			WALL_TILE_BASE+10,	WALL_TILE_BASE+11	; 8	; vacia
	db	0,			0,			0,			0,			0, 			WALL_TILE_BASE+12,	WALL_TILE_BASE+13	; 9	; vacia
	db	0,			0,			0,			0,			0, 			WALL_TILE_BASE+14,	WALL_TILE_BASE+15	; 10	; muro
	db	0,			0,			0,			0,			0, 			WALL_TILE_BASE+16,	WALL_TILE_BASE+17	; 11	; muro
	;; medio
	db	0,			0,			0, 			WALL_OUT_TILE_BASE+0,	WALL_OUT_TILE_BASE+0,	0,			0			; 12	; ladrillo columna del borde izq de 1 pixel negro
	db	0,			0,			0, 			WALL_TILE_BASE+0,	WALL_TILE_BASE+1,	0,			0			; 13	; ladrillo columna pegada al borde izq de 1 pixel negro
	db	0,			0,			0, 			WALL_OUT_TILE_BASE+1,	WALL_OUT_TILE_BASE+1,	0,			0			; 14	; columna de cielo con 1 pixel negro a la izq
	db	0,			0,			0, 			WALL_TILE_BASE+2,	WALL_TILE_BASE+3,	0,			0			; 15	; ladrillo columna centro
	db	0,			0,			0, 			WALL_TILE_BASE+4,	WALL_TILE_BASE+5,	0,			0			; 16	; ladrillo columna der
	db	0,			0,			0, 			WALL_TILE_BASE+6,	WALL_TILE_BASE+7,	0,			0			; 17	; interrogante
	db	0,			0,			0, 			WALL_TILE_BASE+8,	WALL_TILE_BASE+9,	0,			0			; 18	; interrogante
	db	0,			0,			0, 			WALL_TILE_BASE+10,	WALL_TILE_BASE+11,	0,			0			; 19	; vacia
	db	0,			0,			0, 			WALL_TILE_BASE+12,	WALL_TILE_BASE+13,	0,			0			; 20	; vacia
	db	0,			0,			0, 			WALL_TILE_BASE+14,	WALL_TILE_BASE+15,	0,			0			; 21	; muro
	db	0,			0,			0, 			WALL_TILE_BASE+16,	WALL_TILE_BASE+17,	0,			0			; 22	; muro
	;; alto
	db	0,			WALL_OUT_TILE_BASE+0,	WALL_OUT_TILE_BASE+0,	0,			0,			0,			0			; 23	; ladrillo columna del borde izq de 1 pixel negro
	db	0,			WALL_TILE_BASE+0,	WALL_TILE_BASE+1,	0,			0,			0,			0			; 24	; ladrillo columna pegada al borde izq de 1 pixel negro
	db	0,			WALL_OUT_TILE_BASE+1,	WALL_OUT_TILE_BASE+1,	0,			0,			0,			0			; 25	; columna de cielo con 1 pixel negro a la izq
	db	0,			WALL_TILE_BASE+2,	WALL_TILE_BASE+3,	0,			0,			0,			0			; 26	; ladrillo columna centro
	db	0,			WALL_TILE_BASE+4,	WALL_TILE_BASE+5,	0,			0,			0,			0			; 27	; ladrillo columna der
	db	0,			WALL_TILE_BASE+6,	WALL_TILE_BASE+7,	0,			0,			0,			0			; 28	; interrogante
	db	0,			WALL_TILE_BASE+8,	WALL_TILE_BASE+9,	0,			0,			0,			0			; 29	; interrogante
	db	0,			WALL_TILE_BASE+10,	WALL_TILE_BASE+11,	0,			0,			0,			0			; 30	; vacia
	db	0,			WALL_TILE_BASE+12,	WALL_TILE_BASE+13,	0,			0,			0,			0			; 31	; vacia
	db	0,			WALL_TILE_BASE+14,	WALL_TILE_BASE+15,	0,			0,			0,			0			; 32	; muro
	db	0,			WALL_TILE_BASE+16,	WALL_TILE_BASE+17,	0,			0,			0,			0			; 33	; muro
	; ...

	;; Subcolumnas (franja inferior)

MPIPEXS		EQU	0
MPIPES		EQU	5
MPIPEM		EQU	10
MPIPEL		EQU	15

tileSubMap2
	;; suelo
	db	0,			0,			0,			0,			0,			0,			FLOOR_TILE_BASE+0,	FLOOR_TILE_BASE+2	; 1
	db	0,			0,			0,			0,			0,			0,			FLOOR_TILE_BASE+1,	FLOOR_TILE_BASE+3	; 2
	;; suelo + arbusto 1
	db	0,			0,			0,			0, 			0, 			BUSH1_TILE_BASE+0,	FLOOR_TILE_BASE+0,	FLOOR_TILE_BASE+2	; 3
	db	0,			0,			0,			0, 			BUSH1_TILE_BASE+1, 	BUSH1_TILE_BASE+2,	FLOOR_TILE_BASE+1,	FLOOR_TILE_BASE+3	; 4
	db	0,			0,			0,			0, 			BUSH1_TILE_BASE+3, 	BUSH1_TILE_BASE+4,	FLOOR_TILE_BASE+0,	FLOOR_TILE_BASE+2	; 5
	db	0,			0,			0,			0, 			BUSH1_TILE_BASE+5,	BUSH1_TILE_BASE+6,	FLOOR_TILE_BASE+1,	FLOOR_TILE_BASE+3	; 6
	db	0,			0,			0,			0, 			0,			BUSH1_TILE_BASE+7,	FLOOR_TILE_BASE+0,	FLOOR_TILE_BASE+2	; 7
	;; suelo + arbusto 2
	db	0,			0,			0, 			0, 			0,			BUSH2_TILE_BASE+0, 	FLOOR_TILE_BASE+0,	FLOOR_TILE_BASE+2	; 8
	db	0,			0,			0, 			0,			BUSH2_TILE_BASE+1,	BUSH2_TILE_BASE+2, 	FLOOR_TILE_BASE+1,	FLOOR_TILE_BASE+3	; 9
	db	0,			0,			0, 			BUSH2_TILE_BASE+3,	BUSH2_TILE_BASE+2,	BUSH2_TILE_BASE+5, 	FLOOR_TILE_BASE+0,	FLOOR_TILE_BASE+2	; 10
	db	0,			0,			0, 			BUSH2_TILE_BASE+6,	BUSH2_TILE_BASE+7,	BUSH2_TILE_BASE+5, 	FLOOR_TILE_BASE+1,	FLOOR_TILE_BASE+3	; 11
	db	0,			0,			0, 			BUSH2_TILE_BASE+8,	BUSH2_TILE_BASE+9,	BUSH2_TILE_BASE+5, 	FLOOR_TILE_BASE+0,	FLOOR_TILE_BASE+2	; 12
	db	0,			0,			0, 			0,			BUSH2_TILE_BASE+10,	BUSH2_TILE_BASE+11, 	FLOOR_TILE_BASE+1,	FLOOR_TILE_BASE+3	; 13
	db	0,			0,			0, 			0, 			0, 			0, 			FLOOR_TILE_BASE+0,	FLOOR_TILE_BASE+2	; 14
	;; suelo + tuberia minima
	db	0,			0,			0, 			PIPE_TILE_BASE+0,	PIPE_TILE_BASE+1,	PIPE_TILE_BASE+2,	FLOOR_TILE_BASE+0,	FLOOR_TILE_BASE+2	; 15
	db	0,			0,			0, 			PIPE_TILE_BASE+4,	PIPE_TILE_BASE+5,	PIPE_TILE_BASE+6,	FLOOR_TILE_BASE+1,	FLOOR_TILE_BASE+3	; 16
	db	0,			0,			0, 			PIPE_TILE_BASE+8,	PIPE_TILE_BASE+9,	PIPE_TILE_BASE+10,	FLOOR_TILE_BASE+0,	FLOOR_TILE_BASE+2	; 17
	db	0,			0,			0, 			PIPE_TILE_BASE+12,	PIPE_TILE_BASE+13,	PIPE_TILE_BASE+14,	FLOOR_TILE_BASE+1,	FLOOR_TILE_BASE+3	; 18
	db	0,			0,			0, 			PIPE_OUT_TILE_BASE+0,	PIPE_OUT_TILE_BASE+1, 	0, 			FLOOR_TILE_BASE+0,	FLOOR_TILE_BASE+2	; 19
	;; suelo + tuberia chica
	db	0,			0, 			PIPE_TILE_BASE+0,	PIPE_TILE_BASE+1,	PIPE_TILE_BASE+2,	PIPE_TILE_BASE+2, 	FLOOR_TILE_BASE+0,	FLOOR_TILE_BASE+2	; 20
	db	0,			0, 			PIPE_TILE_BASE+4,	PIPE_TILE_BASE+5,	PIPE_TILE_BASE+6,	PIPE_TILE_BASE+6, 	FLOOR_TILE_BASE+1,	FLOOR_TILE_BASE+3	; 21
	db	0,			0, 			PIPE_TILE_BASE+8,	PIPE_TILE_BASE+9,	PIPE_TILE_BASE+10,	PIPE_TILE_BASE+10, 	FLOOR_TILE_BASE+0,	FLOOR_TILE_BASE+2	; 22
	db	0,			0, 			PIPE_TILE_BASE+12,	PIPE_TILE_BASE+13,	PIPE_TILE_BASE+14,	PIPE_TILE_BASE+14, 	FLOOR_TILE_BASE+1,	FLOOR_TILE_BASE+3	; 23
	db	0,			0, 			PIPE_OUT_TILE_BASE+0,	PIPE_OUT_TILE_BASE+1, 	0, 			0, 			FLOOR_TILE_BASE+0,	FLOOR_TILE_BASE+2	; 24
	;; suelo + tuberia media
	db	0, 			PIPE_TILE_BASE+0,	PIPE_TILE_BASE+1,	PIPE_TILE_BASE+2,	PIPE_TILE_BASE+2,	PIPE_TILE_BASE+2, 	FLOOR_TILE_BASE+0,	FLOOR_TILE_BASE+2	; 25
	db	0, 			PIPE_TILE_BASE+4,	PIPE_TILE_BASE+5,	PIPE_TILE_BASE+6,	PIPE_TILE_BASE+6,	PIPE_TILE_BASE+6, 	FLOOR_TILE_BASE+1,	FLOOR_TILE_BASE+3	; 26
	db	0, 			PIPE_TILE_BASE+8,	PIPE_TILE_BASE+9,	PIPE_TILE_BASE+10,	PIPE_TILE_BASE+10,	PIPE_TILE_BASE+10, 	FLOOR_TILE_BASE+0,	FLOOR_TILE_BASE+2	; 27
	db	0, 			PIPE_TILE_BASE+12,	PIPE_TILE_BASE+13,	PIPE_TILE_BASE+14,	PIPE_TILE_BASE+14,	PIPE_TILE_BASE+14, 	FLOOR_TILE_BASE+1,	FLOOR_TILE_BASE+3	; 28
	db	0, 			PIPE_OUT_TILE_BASE+0,	PIPE_OUT_TILE_BASE+1, 	0, 			0, 			0, 			FLOOR_TILE_BASE+0,	FLOOR_TILE_BASE+2	; 29
	;; suelo + tuberia grande
	db	PIPE_TILE_BASE+0, 	PIPE_TILE_BASE+1,	PIPE_TILE_BASE+2,	PIPE_TILE_BASE+2,	PIPE_TILE_BASE+2,	PIPE_TILE_BASE+2, 	FLOOR_TILE_BASE+0,	FLOOR_TILE_BASE+2	; 30
	db	PIPE_TILE_BASE+4, 	PIPE_TILE_BASE+5,	PIPE_TILE_BASE+6,	PIPE_TILE_BASE+6,	PIPE_TILE_BASE+6,	PIPE_TILE_BASE+6, 	FLOOR_TILE_BASE+1,	FLOOR_TILE_BASE+3	; 31
	db	PIPE_TILE_BASE+8, 	PIPE_TILE_BASE+9,	PIPE_TILE_BASE+10,	PIPE_TILE_BASE+10,	PIPE_TILE_BASE+10,	PIPE_TILE_BASE+10, 	FLOOR_TILE_BASE+0,	FLOOR_TILE_BASE+2	; 32
	db	PIPE_TILE_BASE+12, 	PIPE_TILE_BASE+13,	PIPE_TILE_BASE+14,	PIPE_TILE_BASE+14,	PIPE_TILE_BASE+14,	PIPE_TILE_BASE+14, 	FLOOR_TILE_BASE+1,	FLOOR_TILE_BASE+3	; 33
	db	PIPE_OUT_TILE_BASE+0, 	PIPE_OUT_TILE_BASE+1, 	0, 			0, 			0, 			0, 			FLOOR_TILE_BASE+0,	FLOOR_TILE_BASE+2	; 34
	;; suelo + muro
	db	0,			0,			0,			0,			WALL_OUT_TILE_BASE,	WALL_OUT_TILE_BASE,	FLOOR_TILE_BASE+0,	FLOOR_TILE_BASE+2	; 35
	db	0,			0,			0,			0,			WALL_TILE_BASE+14,	WALL_TILE_BASE+15,	FLOOR_TILE_BASE+1,	FLOOR_TILE_BASE+3	; 36
	db	0,			0,			0,			0,			WALL_TILE_BASE+16,	WALL_TILE_BASE+17,	FLOOR_TILE_BASE+0,	FLOOR_TILE_BASE+2	; 37
	db	0,			0,			0,			0,			WALL_OUT_TILE_BASE+1,	WALL_OUT_TILE_BASE+1,	FLOOR_TILE_BASE+1,	FLOOR_TILE_BASE+3	; 38
	;; suelo + muro
	db	0,			0,			WALL_OUT_TILE_BASE,	WALL_OUT_TILE_BASE,	WALL_TILE_BASE+16,	WALL_TILE_BASE+17,	FLOOR_TILE_BASE+0,	FLOOR_TILE_BASE+2	; 39
	db	0,			0,			WALL_TILE_BASE+14,	WALL_TILE_BASE+15,	WALL_TILE_BASE+14,	WALL_TILE_BASE+15,	FLOOR_TILE_BASE+1,	FLOOR_TILE_BASE+3	; 40
	db	0,			0,			WALL_TILE_BASE+16,	WALL_TILE_BASE+17,	WALL_TILE_BASE+16,	WALL_TILE_BASE+17,	FLOOR_TILE_BASE+0,	FLOOR_TILE_BASE+2	; 41
	db	0,			0,			WALL_OUT_TILE_BASE+1,	WALL_OUT_TILE_BASE+1,	WALL_OUT_TILE_BASE+1,	WALL_OUT_TILE_BASE+1,	FLOOR_TILE_BASE+1,	FLOOR_TILE_BASE+3	; 42
	;; suelo + muro
	db	WALL_OUT_TILE_BASE,	WALL_OUT_TILE_BASE,	WALL_TILE_BASE+16,	WALL_TILE_BASE+17,	WALL_TILE_BASE+16,	WALL_TILE_BASE+17,	FLOOR_TILE_BASE+0,	FLOOR_TILE_BASE+2	; 43
	db	WALL_TILE_BASE+14,	WALL_TILE_BASE+15,	WALL_TILE_BASE+14,	WALL_TILE_BASE+15,	WALL_TILE_BASE+14,	WALL_TILE_BASE+15,	FLOOR_TILE_BASE+1,	FLOOR_TILE_BASE+3	; 44
	db	WALL_TILE_BASE+16,	WALL_TILE_BASE+17,	WALL_TILE_BASE+16,	WALL_TILE_BASE+17,	WALL_TILE_BASE+16,	WALL_TILE_BASE+17,	FLOOR_TILE_BASE+0,	FLOOR_TILE_BASE+2	; 45
	db	WALL_OUT_TILE_BASE+1,	WALL_OUT_TILE_BASE+1,	WALL_OUT_TILE_BASE+1,	WALL_OUT_TILE_BASE+1,	WALL_OUT_TILE_BASE+1,	WALL_OUT_TILE_BASE+1,	FLOOR_TILE_BASE+1,	FLOOR_TILE_BASE+3	; 46
	;; suelo + arbusto 2 (grande)
	db	0,			0,			0, 			BUSH2_TILE_BASE+1,	BUSH2_TILE_BASE+2,	BUSH2_TILE_BASE+5, 	FLOOR_TILE_BASE+0,	FLOOR_TILE_BASE+2	; 47
	db	0,			0,			BUSH2_TILE_BASE+3,	BUSH2_TILE_BASE+2,	BUSH2_TILE_BASE+5,	BUSH2_TILE_BASE+5, 	FLOOR_TILE_BASE+1,	FLOOR_TILE_BASE+3	; 48
	db	0,			0,			BUSH2_TILE_BASE+6,	BUSH2_TILE_BASE+7,	BUSH2_TILE_BASE+5,	BUSH2_TILE_BASE+5, 	FLOOR_TILE_BASE+0,	FLOOR_TILE_BASE+2	; 49
	db	0,			0,			BUSH2_TILE_BASE+8,	BUSH2_TILE_BASE+9,	BUSH2_TILE_BASE+5,	BUSH2_TILE_BASE+5, 	FLOOR_TILE_BASE+1,	FLOOR_TILE_BASE+3	; 50
	db	0,			0,			0, 			BUSH2_TILE_BASE+10,	BUSH2_TILE_BASE+4,	BUSH2_TILE_BASE+5, 	FLOOR_TILE_BASE+0,	FLOOR_TILE_BASE+2	; 51


tileSubMap_void
	defs	8,0


	;; CONFIGURACION DE COLOR POR FRANJAS

bar_colors0
			db	COLOR_AZUL_PASTEL
			db	COLOR_BLANCO
bar_colors1
			db	COLOR_ROJO
			db	COLOR_NARANJA
bar_colors2
			db	COLOR_VERDE
			db	COLOR_VERDE_BRILLANTE
bar_colors3
			db	COLOR_CYAN
			db	COLOR_CYAN_PASTEL
bar_colors4
			db	COLOR_AMARILLO
			db	COLOR_AMARILLO_BRILLANTE

	;; Cambios en colores de franjas dinamicamente

	IF	DINAMIC_PALETTE_CHANGES

MPAL00	EQU	DINAMIC_PALETTE_CHANGES + 0
MPAL01	EQU	DINAMIC_PALETTE_CHANGES + 1

	ALIGN	2

	;; Indice de posibles cambios

myMap_colors
	dw	bar_color_to_walls
	dw	bar_color_from_walls

	;; Codigo de posibles cambios

	;; Pone la tercera franja de amarillos

bar_color_to_walls
;	ld	hl,bar_colors0
;	ld	de,_game_common_colors_bar0 + 1
;	ldi
;	ldi

;	ld	hl,bar_colors4
;	ld	de,_game_common_colors_bar1 + 1
;	ldi
;	ldi

	ld	hl,bar_colors4;bar_colors1
	ld	de,_game_common_colors_bar2 + 1
	ldi
	ldi

;	ld	hl,bar_colors3
;	ld	de,_game_common_colors_bar3 + 1
;	ldi
;	ldi

	ret

	;; Pone la tercera franja del color por defecto (verdes)

bar_color_from_walls

;	ld	hl,bar_colors0
;	ld	de,_game_common_colors_bar0 + 1
;	ldi
;	ldi

;	ld	hl,bar_colors1
;	ld	de,_game_common_colors_bar1 + 1
;	ldi
;	ldi

	ld	hl,bar_colors2
	ld	de,_game_common_colors_bar2 + 1
	ldi
	ldi

;	ld	hl,bar_colors3
;	ld	de,_game_common_colors_bar3 + 1
;	ldi
;	ldi

	ret

	ELSE

MPAL00	EQU	0
MPAL01	EQU	0

	ENDIF



