
	; Redimensiona el tamanyo y posicion de la pantalla manteniendo los 50hz

	; *** OJO, no es fiable si viene con una pantalla menor de 312 scanlines (r4 = 38)
	;	   (puede funcionar o no dependiendo del valor que se pida para R7)

	; - Previamente debe haberse sincronizado con el VBL
	; - El puntero de interrupcion (#38) debe no hacer nada.

	; h = x, l = w
	; d = y, e = h

redim_screen
	ld	bc,#bc01	; w
	out	(c),c
	inc	b
	out	(c),l

	dec	b
	inc	c
;	ld	bc,#bc02	; x
	out	(c),c
	inc	b
	out	(c),h

	ld	bc,#bc06	; h
	out	(c),c
	inc	b
	out	(c),e

	dec	b		; *** NUEVO	R7 = #7f para evitar problemas
	inc	c
	out	(c),c
	ld	bc,#bd7f
	out	(c),c

currentR7
	ld	a,CURRENT_R7_VALUE
	sub	d
	jr	z,screen_ok

;	ei

	add	38		; a = r4 value

	ld	bc,#bc04
	out	(c),c
	inc	b
	out	(c),a		; r4 = a

	; calcula el numero de halts segun R4

	cp	7-2
	jr	c, no_wait_halts
	ld	e,1
	cp	13-2
	jr	c, r4_wait_halts	; e = 1
	inc	e 
	cp	21-2
	jr	c, r4_wait_halts	; e = 2
	inc	e
	cp	26-2
	jr	c, r4_wait_halts	; e = 3
	inc	e
	cp	33-2
	jr	c, r4_wait_halts	; e = 4
	inc	e			; e = 5
r4_wait_halts

	ei

	; calcula el numero de halts segun R7

	ld	a,d
	ld	c,2			; * usa C en vez de B para no pisar B (=#bd)
	cp	33
	jr	nc, wait_halts
	inc	c
	cp	27
	jr	nc, wait_halts
	inc	c
	cp	21
	jr	nc, wait_halts
	inc	c
	cp	14
	jr	nc, wait_halts
	inc	c
wait_halts

	ld	a,c			; espera el menor de C y E
	cp	e
	jr	c, wait_halts_loop
	ld	c,e

wait_halts_loop
	halt
	dec	c
	jr	nz, wait_halts_loop
no_wait_halts

	di

	ld	c,38
	out	(c),c		; r4 = 38
	ld	bc,#bc07
	out	(c),c
	inc	b
	out	(c),d		; r7 = d
	ld	a,d
	ld	(currentR7 + 1),a
screen_ok

	ret
